﻿String.prototype.replaceAll = function (find, replaceWith) {
    return this.replace(new RegExp(find, 'g'), replaceWith);
};

String.prototype.escapeHtml = function() {
    return this.replaceAll("<", "&lt;").replaceAll(">", "&gt;");
};

String.prototype.toBoolean = function() {
    switch (this.toLowerCase()) {
        case "true": case "yes": case "1": return true;
        case "false": case "no": case "0": case null: return false;
        default: return Boolean(this);
    }
}

Date.prototype.getHoursAmPm = function () {
    var hours = this.getHours();
    if (hours == 0) {
        return 12;
    } else if (hours > 12) {
        return hours - 12;
    } else {
        return hours;
    }
}


Date.prototype.getAmPm = function() {
    if (this.getHours() < 12) {
        return "AM";
    } else {
        return "PM";
    }
}

moment.fn.getHoursAmPm = function () {
    var hours = this.hours();
    if (hours == 0) {
        return 12;
    } else if (hours > 12) {
        return hours - 12;
    } else {
        return hours;
    }
}

moment.fn.getAmPm = function () {
    if (this.hours() < 12) {
        return "AM";
    } else {
        return "PM";
    }
}

moment.fn.totalMinutes = function() {
    return this.hours() * 60 + this.minutes();
}

moment.fn.isInPast = function() {
    return moment().isAfter(this, 'd');
}
moment.fn.getTempTime = function (isAmPmTime) {    
    if (isAmPmTime) {
        return {
            hours: this.getHoursAmPm(),
                minutes:
            this.format("mm"),
                amPmDesignator:
            this.getAmPm()
        }
    } else {        
        return {
            hours: this.hours(),
            minutes: this.format("mm")
        }
    }
}

moment.fn.getTimeFromTempTime = function (tempTime, isAmPmTime) {
    if (isAmPmTime) {
        return moment(tempTime.hours + ":" + tempTime.minutes + " " + tempTime.amPmDesignator, "h:m a");
    } else {
        return moment(tempTime.hours + ":" + tempTime.minutes, "h:m");
    }
}