app.config(['$routeProvider', '$locationProvider', '$httpProvider', function ($routeProvider, $locationProvider, $httpProvider)
{
    $httpProvider.interceptors.push('AuthInterceptor');

	$routeProvider
		.when('/', {
			templateUrl: 'views/appointmentbook.html',
			controller: 'AppointmentBookController',
			resolve: {
			    busInfo: ['restServer', function (restServer) {
			        return restServer.LoadBusinessInfo().then(
                  function success(response) {
                      return response.data; },
                  function error(reason) { return false; }
                );
			    }]
			}
		})
        .when('/filters', {
            templateUrl: 'views/AppointmentBookFilters.html',
            controller: 'AppointmentBookFiltersController'
	    })
        .when('/editor', {
            templateUrl: 'views/AppointmentBookEditor.html',
            controller: 'AppointmentBookEditorController'
        })
        .when('/blockeditor', {
            templateUrl: 'views/BlockEditor.html',
            controller: 'BlockEditorController'
	    })
        .when('/standing', {
            templateUrl: 'views/Standing.html',
            controller: 'StandingController'
	    })
        .when('/kendo', {
            templateUrl: 'views/Kendo.html',
            controller: 'KendoController'
        })
        .when('/test', {
            templateUrl: 'views/Test.html',
            controller: 'TestController'
        })
        .when('/client', {
            templateUrl: 'views/ClientEditor.html',
            controller: 'ClientEditorController'
        })
		.otherwise({
			redirectTo: '/'
		});
	
}]);