

app.controller('AppointmentBookController', [
    '$scope', '$http', '$q', 'restServer', '$location', 'Enums', '$rootScope', 'Security', '$datepicker', 'busInfo', 'dateTimeFilter',
    function ($scope, $http, $q, restServer, $location, enums, $rootScope, security, $datepicker, busInfo, dateTime) {
        //#region Local Variables
        var cellHeight = 35;
        var columnWidth = 200;
        var leftRigthBorderWidth = 2;
        var headerMargin;
        var appointmentLeftBarWidth = 20;
        var headerOffset;
        var numberOfDimensionsPerRequest = 10;
        var timeColumnWidth = 50;
        var columnDateFormat = 'M/D/YYYY';
        var bookStartTime;
        var bookEndTime;
        var appointmentBookLoaded = false;
        var filterBarHeight = 48;
        var defaultEmployeeIds = [];
        var divCellHighlight;
        var divNewBooking;
        var divAppointmentDetails;
        var divBlockDetails;
        var divEditor;

        var parentColumns;
        var columnBookings = [];
        var lastRequestedDimension = 0;
        var copyCutAppointDetailId;
        var columnRight;
        var businessInfo;
        var isCutting = false;
        var isCopying = false;
        var cutCopyIds = [];

        var zIndexTime = 1000;
        var zIndexStructure = 2;
        var zIndexBooking = 5;
        var zIndexSchedule = 3;
        var zIndexPopup = 1001;
        var zIndexCellHighlight = 4;
        var zIndexClick = 4;

        var appointmentDataTypeId = 2;
        var blockDataTypeId = 3;

        var hideColumnsWithoutSchedule;

        var dragOffsetX;
        var dragOffsetY;
        var highlightedCell;
        var currentlyDraggableElement;

        var copyCutMoveRevert;
        var copyCutMoveBookingServerCall;
        var copyCutMoveBooking;

        var deletedIds;
        var messageConfig;
        var isAmPmTime = true;

        $scope.editAppointmentChoice = 1;
        $scope.editBlockChoice = 1;
        // SET CURRENT DATE


        var dateType = enums.AppointmentBookDateTypeFilter.Day;
        var dates = [$scope.dateString];

        var appointmentEditorLocation = "views/AppointmentBookEditor.html";
        var blockEditorLocation = "views/BlockEditor.html";
        var appointmentBookFiltersLocation = "views/AppointmentBookFilters.html";
        var appointmentBookMenuLocation = "views/AppointmentBookMenu.html";
        //#endregion

        angular.element(document).ready(function() {
//        $datepicker.defaults.dateFormat = 'dd/MM/yyyy';
//        alert(moment().format("L"));
            //Loads CSS hacks for Mobile (fixes typeaheads not closing on touch)
            if (device.mobile() || device.tablet()) {
                $('<link>')
                    .appendTo('head')
                    .attr({ type: 'text/css', rel: 'stylesheet' })
                    .attr('href', './css/hacks.css');
            }


            $(document).on("touchmove", scroll);
            $(document).on("scroll", scroll);
            // handles when screen orientation changes.  There's a orientationchanged event in jquery mobile, but we don't use that
            $(window).on("resize", function() {
                // Only no this for mobile browsers and only when width has changed.  Height can change without width when scrolling down and the url box goes away.
                if ((device.mobile() || device.tablet()) && $(window).width() != previousWindowWidth) {
                    detectPhoneMode();
                    filterBook();
                }
            });
        });

        //#region Functions

        function CalculatePercentageBooked(relatedColumnIds) {
            columnBookings.forEach(function(column) {
                if (relatedColumnIds.indexOf(column.columnId) >= 0) {
                    CalculatePercentageBookedForColumn(column);
                }
            });
        };

        function HideColumnsWithoutSchedule() {
            if (hideColumnsWithoutSchedule == undefined) {
                var setting = $scope.getSetting(enums.SettingEnum.HideColumnsWithoutSchedules);
                if (setting != null) {
                    hideColumnsWithoutSchedule = setting.toBoolean();
                } else {
                    hideColumnsWithoutSchedule = false;
                }
            }
            return hideColumnsWithoutSchedule;
        };

        function CalculatePercentageBookedForColumn(column) {
            var headerBarDiv = $("#Header" + column.columnId + " .headerBar");
            headerBarDiv.empty();

            var bookableMinutes = column.bookableMinutes;
            var bookedMinutes = 0;
            $("#" + column.columnId).children(".appointment, .block").each(function() {
                var booking = $(this);
                if (booking.data("type") == appointmentDataTypeId) {
                    bookedMinutes += parseInt(booking.data("bm"));
                } else {
                    var includeInProductivity = booking.data("ip");
                    var minutes = booking.data("m");
                    if (includeInProductivity) {
                        bookedMinutes += minutes;
                    } else {
                        bookableMinutes -= minutes;
                    }
                }
            });

            var percentage;
            if (bookableMinutes <= 0) {
                percentage = 0;
            } else {
                percentage = bookedMinutes / bookableMinutes;
            }
            var width = columnWidth * percentage;
            if (width >= columnWidth) {
                width = columnWidth - 1;
            }

            percentage = Math.round(percentage * 100);
            var backgroundColor;
            if (percentage <= 25) {
                backgroundColor = "red";
            } else if (percentage <= 75) {
                backgroundColor = "yellow";
            } else {
                backgroundColor = "rgb(78,206,34)";
            }
            headerBarDiv.append("<div class='percentBookedShadow'></div>");
            headerBarDiv.append("<div style='background-color:" + backgroundColor + ";position:absolute;width:" + width + "px;height:12px;'></div>");
            headerBarDiv.append("<div class='percentBookedLabel'>" + percentage + "%</div>");
        }

        function CalculatePercentageBookedForColumnId(columnId) {
            var column = _.where(columnBookings, { columnId: columnId })[0];

            CalculatePercentageBookedForColumn(column);
        };

        function CheckColumnHiding(relatedColumnIds) {
            for (var i = columnBookings.length - 1; i >= 0; i--) {
                var column = columnBookings[i];
                if (relatedColumnIds.indexOf(column.columnId) >= 0) {
                    if (((HideColumnsWithoutSchedule() && !column.hasBookableSchedule) || !column.allowBooking) &&
                        $("#" + column.columnId).children(".appointment").length == 0) {
                        HideColumn(column, i);
                    }
                }
            }
        };

        function HideColumn(column) {
            // remove column
            var htmlColumn = $("#" + column.columnId);
            var rootHeaderId = htmlColumn.data("rootHeaderId");
            var rootHeaderColumn = $("#" + rootHeaderId);

            //remove header column
            htmlColumn.remove();
            $("#Header" + column.columnId).remove();

            var newRootHeaderWidth = rootHeaderColumn.outerWidth() - columnWidth;
            if (newRootHeaderWidth > 0) {
                rootHeaderColumn.css("width", newRootHeaderWidth);
            } else {
                rootHeaderColumn.remove();
            }

            var divRows = $("#divRows");
            divRows.css("width", divRows.width() - columnWidth);
            $("#divClickOverlay").width($("#divClickOverlay").width() - columnWidth);
            column.remove = true;
        }

        function MarkDraggable(id) {
            currentlyDraggableElement = $('#' + id).draggable({
                drag: function(event) {
                    var cell = GetCellByCoordinates(event.pageX - dragOffsetX, event.pageY - dragOffsetY, true);
                    if (cell == null) {
                        divCellHighlight.hide();
                    } else if (highlightedCell == undefined || cell.top != highlightedCell.top || cell.left != highlightedCell.left) {
                        highlightedCell = cell;
                        divCellHighlight.css("left", cell.left + timeColumnWidth).css("top", cell.top + headerOffset).show();
                    }
                },
                start: function(event) {
                    $(this).css("z-index", zIndexBooking + 1);
                    divAppointmentDetails.hide();
                    divBlockDetails.hide();
                    if ($(this).data("cutId") != undefined || $(this).data("isCopy") != undefined) {
                        dragOffsetX = event.offsetX;
                        dragOffsetY = event.offsetY;
                        // if just a copy, need to make a clone of div to replace the one being moved
                        if ($(this).data("isCopy") != undefined) {
                            CopyAppointDetail($(this));
                        }
                    } else {
                        // Need to do it this way instead of using offset like above b/c for some reason positioin is different.  Need to investigate.
                        dragOffsetX = event.pageX - $(this).position().left - timeColumnWidth;
                        dragOffsetY = event.pageY - $(this).position().top - headerOffset;
                    }

                },
                stop: function(event, ui) {
                    $(this).draggable("destroy").css("z-index", zIndexBooking);
                    currentlyDraggableElement = undefined;
                    divCellHighlight.hide();
                    var cell = GetCellByCoordinates(event.pageX - dragOffsetX, event.pageY - dragOffsetY, true);
                    if (cell) {
                        // the drop cell isn't the same as the original cell of the booking so proceed with drop
                        if ($(this).parent().attr("id") != cell.columnId || ui.originalPosition.top != cell.top) {
                            CopyCutMove($(this), cell, ui.originalPosition);
                            return;
                        }
                    }
                    // Drop coordinates outside of cell grid so just set dragged booking back to original position
                    $(this).css("left", ui.originalPosition.left).css("top", ui.originalPosition.top);
                    if ($(this).data("copyReplaceId") != undefined) {
                        $("#" + $(this).data("copyReplaceId")).remove();
                    }
                }
            });
        };

        function CopyAppointDetail(appointDetail) {
            var clone = appointDetail.clone();
            var guid = NewGuid();
            appointDetail.data("copyReplaceId", guid);
            clone.attr("id", guid);
            clone.data("copyId", appointDetail.data("copyId"));
            clone.appendTo(appointDetail.parent());

            return guid;
        };

        function CopyCutMove(booking, cell, originalPosition) {
            var cutId = booking.data("cutId");
            var originalColumnId = booking.parent().attr("id");

            if (cutId != undefined) {
                // Move booking back to original spot in the case of a drag/drop from clipboard
                booking.css("top", originalPosition.top).css("left", originalPosition.left);

                // hide highlight div.  need to hide and not just remove in case change is reverted
                booking.parent().removeClass("divSelected").addClass("hideHighlight").hide();
                if ($("#divCutCopyDetails").children().not(".hideHighlight").length == 0) {
                    $scope.closeCutCopy();
                }

                // Switch booking to original appointmetn and act on that
                var originalBooking = $("#" + cutId);
                if (originalBooking.length > 0) {

                    booking = originalBooking;
                    originalColumnId = booking.parent().attr("id");
                    // Need this in case of revert
                    originalPosition.top = booking.position().top;
                } else { // This is the case where they've changed days and the original appointment is no longer on the screen.  Need to create a new instance of the div.
                    booking = booking.clone();
                    booking.attr("id", cutId);
                    originalColumnId = undefined; // This doens't matter as since the original column is no longer on the screen, nothing nees to be reverted back
                    originalPosition.top = 0;
                }

                for (var i = cutCopyIds.length - 1; i >= 0; i--) {
                    if (cutCopyIds[i].appointDetailId == cutId) {
                        cutCopyIds.splice(i, 1);
                        break;
                    }
                }
                $("#" + cutId + "Overlay").hide();
            }
            booking.css("top", cell.top).css("left", "auto");

            var destinationColumnId = cell.columnId;
            booking.detach().appendTo("#" + destinationColumnId);
            AdjustColumnCellsForMultiBooking(destinationColumnId);
            CalculatePercentageBookedForColumnId(destinationColumnId);
            if (originalColumnId != undefined) {
                AdjustColumnCellsForMultiBooking(originalColumnId);
                CalculatePercentageBookedForColumnId(originalColumnId);
            }

            copyCutMoveRevert = function() {
                copyCutMoveRevertCallback(booking, originalPosition.top, originalColumnId, destinationColumnId);
            };
            validateBookingLocation(destinationColumnId, {
                    top: cell.top,
                    id: booking.attr("id"),
                    height: booking.height(),
                    dataTypeId: booking.data("type"),
                    newBooking: false
                }, cell,
                function() {
                    CopyCutMoveFinal(booking,
                        cell);
                },
                copyCutMoveRevert);
        };

        function copyCutMoveRevertCallback(booking, originalTop, originalColumnId, destinationColumnId) {
            booking.css("top", originalTop);

            var copyId = booking.data("copyId");

            if (copyId == undefined) {
                booking.detach();
                if (originalColumnId != undefined) { // Would be the case if reverting a cut and the original column was no longer on the screen
                    booking.appendTo("#" + originalColumnId);
                }
            } else {
                booking.remove();
            }
            AdjustColumnCellsForMultiBooking(destinationColumnId);
            CalculatePercentageBookedForColumnId(destinationColumnId);
            if (originalColumnId != undefined) {
                AdjustColumnCellsForMultiBooking(originalColumnId);
                CalculatePercentageBookedForColumnId(originalColumnId);
            }
        }

        function CopyCutMoveFinal(booking, cell) {
            WireUpBookingClicking(booking.attr("id"));
            if (booking.data("cutId") != undefined) {
                // remove hidden parent b/c don't need anymore
                $("#" + booking.data("cutId")).parent().remove();
            }

            if (booking.data("copyId") != undefined) {
                $("#" + booking.attr("id") + " .confirm").removeClass().addClass("confirm backRed");
                $scope.setAppointStateIndicator(booking.attr("id"), enums.AppointStateEnum.Booked);
            }

            copyCutMoveBooking = booking;
            if (booking.data("copyId") != undefined) {
                copyCutMoveBookingServerCall = function(warningsAlreadyChecked) {
                    restServer.CopyAppointDetail(booking.attr("id"), booking.data("copyId"), cell.date, cell.time, cell.employeeGlobalId, warningsAlreadyChecked, onCopyAppointDetailSuccess);
                }
                copyCutMoveBookingServerCall(false);
            } else {
                if (booking.data("type") == appointmentDataTypeId) {
                    copyCutMoveBookingServerCall = function(warningsAlreadyChecked) {
                        restServer.MoveAppointDetail(booking.attr("id"), cell.date, cell.time, cell.employeeGlobalId, warningsAlreadyChecked, onMoveAppointDetailSuccess);
                    }
                    copyCutMoveBookingServerCall(false);
                } else {
                    restServer.MoveAppointBlock(booking.attr("id"), cell.date, cell.time, cell.employeeGlobalId);
                }
            }
        }

        // booking needs dataTypeId, top, height and id props
        function validateBookingLocation(columnId, booking, cell, proceedCallback, revertCallback) {
            var column = _.where(columnBookings, { columnId: columnId })[0];

            var startMinutes = cell.startMinutes;
            var endMinutes = booking.height / cellHeight * $rootScope.appointmentBookIncrement + startMinutes;

            var lastEndMinutes;
            var foundStart = false;
            var applicableSchedules = [];

            // Schedules need to be in asc time order for this to work
            for (var i = 0; i < column.schedules.length; i++) {
                var schedule = column.schedules[i];
                var scheduleStartMinutes = 0;
                if (lastEndMinutes != undefined) {
                    scheduleStartMinutes = lastEndMinutes;
                }
                var scheduleEndMinutes = scheduleStartMinutes + schedule.totalMinutes;
                lastEndMinutes = scheduleEndMinutes;

                if (!foundStart && startMinutes < scheduleEndMinutes) {
                    foundStart = true;
                }

                if (foundStart) {
                    applicableSchedules.push(schedule);
                }

                // Found end schedule
                if (endMinutes > scheduleStartMinutes && endMinutes <= scheduleEndMinutes) {
                    break;
                }
            }

            var allowBookingFailed = false;
            var allowDoubleBookingFailed = false;
            var outsideWorkTimeFailed = false;
            var message = "";

            if (moment(column.date, columnDateFormat).isInPast()) {
                message += "You are attempting to book an appointment in the past.<br/>  ";
            }

            booking.cellSharingBookings = undefined;

            // Dan said he'd want to see all messages so need to concat but make sure not to duplicate
            applicableSchedules.forEach(function(schedule) {
                if (!outsideWorkTimeFailed && !schedule.workType.isBookableTime) {
                    outsideWorkTimeFailed = true;
                    message += "The employee you have selected is not scheduled to work at this time.<br/>  ";
                }
                if (!allowBookingFailed && !schedule.allowBooking) {
                    allowBookingFailed = true;
                    message += "The employee you have selected doesn't allow booking.<br/>  ";
                }
                if (!allowDoubleBookingFailed && !schedule.allowDoubleBooking) {
                    if (booking.cellSharingBookings == undefined) {
                        GetCellSharingBookings(booking, GetSortedBookings(columnId));
                    }

                    if (booking.cellSharingBookings.length > 0) {
                        if (booking.newBooking || checkDoubleBook(booking)) {
                            allowDoubleBookingFailed = true;
                            message += "The employee you have selected can't be double booked at this time.<br/>  ";
                        }
                    }
                }
            });

            if (message == "") {
                proceedCallback();
            } else {
                message += "Do you want to continue?";
                showMessage(message, {
                    buttonsType: enums.ButtonTypeEnum.YesNo,
                    callback: function(result) {
                        if (result == enums.MessageBoxButtonResult.Yes) {
                            proceedCallback();
                        } else if (revertCallback != undefined) {
                            revertCallback();
                        }
                    }
                });
            }
        };

        function checkDoubleBook(booking) {
            var found = false;
            // Build non gap steps for appointment being acted upoin
            var nongaps = [];
            var top = $("#" + booking.id).position().top;
            $("#" + booking.id).children(".gap,.nongap").each(function() {
                var bottom = top + $(this).height();
                if ($(this).hasClass("nongap")) {
                    nongaps.push({
                        top: top,
                        bottom: bottom
                    });
                }
                top = bottom;
            });

            // Iterate potential double book checking each against booking being acted upon
            booking.cellSharingBookings.forEach(function(potentialDoubleBook) {
                top = $("#" + potentialDoubleBook.id).position().top;

                // Look at each nongap step to see if overlaps booking nongap step
                $("#" + potentialDoubleBook.id).children(".gap,.nongap").each(function() {

                    var bottom = top + $(this).height();
                    if ($(this).hasClass("nongap")) {
                        nongaps.forEach(function(nongap) {
                            if (bottom > nongap.top && top < nongap.bottom) {
                                found = true;
                            }
                        });
                    }
                    top = bottom;
                });
            });
            return found;
        }

        function WriteAppointments(response) {
            response.forEach(function(r) {
                var columnId = GetColumnId(r.date, r.employeeGlobalId);
                var columnMatches = _.where(columnBookings, { columnId: columnId });
                if (columnMatches.length > 0) {
                    var column = columnMatches[0];
                    column.appointments = [];
                    r.appointments.forEach(function(appointmentHeader) {

                        for (var i = 0; i < appointmentHeader.appointDetails.length; i++) {
                            var appointDetail = appointmentHeader.appointDetails[i];
                            appointDetail.hasSiblingAppointDetails = appointmentHeader.appointDetails.length > 1;
                            appointDetail.bookingMethodEnum = appointmentHeader.bookingMethodEnum;
                            appointDetail.appointHeaderId = appointmentHeader.appointHeaderId;
                            column.appointments.push(appointDetail);
                            var bookedMinutes = 0;
                            appointDetail.appointDetailSteps.forEach(function(step) {
                                if (step.serviceStepTypeEnum != enums.ServiceStepTypeEnum.Gap) {
                                    bookedMinutes += step.stepMinutes;
                                }
                            });

                            var appointDetailStartTime = moment(appointDetail.startTime);
                            var appointDetailEndTime = moment(appointDetail.startTime).add(appointDetail.totalMinutes, 'm');
                            if (appointDetailEndTime > bookEndTime) {
                                expandBook(appointDetailEndTime);
                            }

                            var cell = GetCellByIds(r.date, appointDetailStartTime.format("H-m"), r.employeeGlobalId);
                            // If appointment starts before book start time, display appointment at book start time
                            if (cell == null && appointDetailStartTime.totalMinutes() < bookStartTime.totalMinutes()) {
                                cell = GetCellByIds(r.date, bookStartTime.format("H-m"), r.employeeGlobalId);
                            }


                            if (cell != null) {
                                var height = 0;
                                var top = cell.top;

                                var id = appointDetail.appointDetailId;

                                appointDetail.appointDetailSteps.forEach(function(appointDetailStep) {

                                    height += (appointDetailStep.stepMinutes / $rootScope.appointmentBookIncrement * cellHeight);
                                });

                                var appointmentHtml = buildAppointmentHtml(appointDetail, appointmentHeader);
                                // Overlay for showing a shadow over when filtering
                                appointmentHtml += "<div id='" + id + "Overlay' class='appointmentOverlay'><div>";

                                // If the appointment extends beyond the height of the book, shrink it to just the remaining space
                                if (top + height > $("#" + columnId).height()) {
                                    height = $("#" + columnId).height() - top;
                                }

                                WriteDiv({
                                    Height: height,
                                    Width: columnWidth - leftRigthBorderWidth,
                                    Top: top,
                                    ClassName: "draggable appointment",
                                    Display: appointmentHtml,
                                    Id: id,
                                    ZIndex: zIndexBooking,
                                    container: "#" + columnId,
                                    dataAttr: " data-type='" + appointmentDataTypeId + "' data-bm='" + bookedMinutes + "'"
                                });

                                if (appointDetail.currentAppointStateEnum != enums.AppointStateEnum.Booked) {
                                    $scope.setAppointStateIndicator(id, appointDetail.currentAppointStateEnum);
                                }

                                WireUpBookingClicking(id, appointDetail.currentAppointStateEnum);
                            }
                        }
                    });
                }
            });
        };

        function buildAppointmentHtml(appointDetail, appointHeader) {
            var html = '';
            var rows = [];
            var currentRow;
            _.sortBy(appointDetail.appointDetailSteps, function(step) {
                return step.stepNumber;
            }).forEach(function(appointDetailStep) {
                if (currentRow == undefined || currentRow.type != appointDetailStep.serviceStepTypeEnum) {
                    currentRow = {
                        type: appointDetailStep.serviceStepTypeEnum,
                        height: 0
                    }
                    rows.push(currentRow);
                }
                currentRow.height += (appointDetailStep.stepMinutes / $rootScope.appointmentBookIncrement) * cellHeight;
            });

            var leftBarBackgroundColorStyle = '';
            if (appointDetail.serviceCatBackgroundColorRgba != undefined) {
                leftBarBackgroundColorStyle = "background-color: rgba(" + appointDetail.serviceCatBackgroundColorRgba[0] + ", " + appointDetail.serviceCatBackgroundColorRgba[1] + ", " + appointDetail.serviceCatBackgroundColorRgba[2] + ", " + appointDetail.serviceCatBackgroundColorRgba[3] + ");";
            }

            var mainBackgroundColorStyle = '';
            if (appointDetail.appointCatBackgroundColorRgba != undefined) {
                mainBackgroundColorStyle = "background-color: rgb(" + appointDetail.appointCatBackgroundColorRgba[0] + ", " + appointDetail.appointCatBackgroundColorRgba[1] + ", " + appointDetail.appointCatBackgroundColorRgba[2] + ");";
            }
            var foregroundColorStyle = '';
            if (appointDetail.appointTypeForegroundColorRgba != undefined) {
                foregroundColorStyle = "color: rgba(" + appointDetail.appointTypeForegroundColorRgba[0] + ", " + appointDetail.appointTypeForegroundColorRgba[1] + ", " + appointDetail.appointTypeForegroundColorRgba[2] + ", " + appointDetail.appointTypeForegroundColorRgba[3] + ");";
            }
            var fontStyle = '';
            if (appointDetail.appointTypeFontStyle != undefined) {
                fontStyle = "font-style: " + appointDetail.appointTypeFontStyle + ";";
            }

            var detailsWritten = false;
            var top = 0;
            var appointmentRightBarWidth = columnWidth - appointmentLeftBarWidth - leftRigthBorderWidth;
            html += GetConfirmIndicator(appointDetail.appointConfirmStateEnum);
            rows.forEach(function(row) {

                if (row.type == enums.ServiceStepTypeEnum.Gap) {
                    html += "<div style='border-right:1px solid black;float:left;width:" + appointmentLeftBarWidth + "px;" + leftBarBackgroundColorStyle + ";height:" + row.height + "px'></div>"
                        + "<div class='gap' style='margin-left:" + appointmentLeftBarWidth + "px;height:" + row.height + "px;width:" + appointmentRightBarWidth + "px;'/>";
                } else {
                    html += "<div style='border-right:1px solid black;float:left;width:" + appointmentLeftBarWidth + "px;" + leftBarBackgroundColorStyle + ";height:" + row.height + "px'></div>"
                        + "<div class='step nongap' style='margin-left:" + appointmentLeftBarWidth + "px;height:" + row.height + "px;width:" + appointmentRightBarWidth + "px;" + mainBackgroundColorStyle + "'>";
                    if (!detailsWritten) {
                        html += "<span class='clientName' style='" + foregroundColorStyle + fontStyle + "'>" + appointDetail.clientDisplayName + "</span>";
                        // TODO: Figure out best way to write conditional text based upon row height
                        if (row.height > cellHeight) {
                            html += "<br/><span class='serviceName'>" + appointDetail.serviceDisplayName;
                            html += "</span><br/><span class='serviceShortcut'>" + appointDetail.serviceShortcut;
                            html += "</span><br/>" + getAdditionalAppointDetailIndicators(appointDetail, appointHeader);
                        }

                        detailsWritten = true;
                    }
                    html += "</div>";
                }
                top += row.height;
            });

            return html;
        };

        function getAdditionalAppointDetailIndicators(appointDetail, appointHeader) {
            var html = "";
            if (appointDetail.hasSiblingAppointDetails != undefined && appointDetail.hasSiblingAppointDetails) {
                html += "<img src='img/Appt_Multiple.png' title='Appointment has multiple services' />";
            }
            if (appointDetail.appointStandingDefnDetailId != undefined) {
                html += "<img src='img/Appt_Standing_18.png' title='Standing appointment' />";
            }
            if (appointDetail.prebookSettingId != undefined) {
                html += "<img src='img/Appt_Prebooked_18.png' title='Prebooked' />";
            }
            if (appointDetail.noteCount > 0) {
                html += "<img src='img/Appt_HasNotes.png' title='Has notes' />";
            }

            if (appointDetail.clientFirstVisitDate == undefined) {
                html += "<img src='img/ApptIcon_NewClient_18.png' title='New client' />";
            }
            if (appointHeader.bookingMethodEnum === enums.BookingMethodEnum.Online) {
                html += "<img src='img/icon_cloudarrow.png' style='float:right' title='Booked online' />";
            }
            switch (appointDetail.genderPreferenceEnum) {
            case enums.GenderPreferenceEnum.FemaleOnly:
                html += "<img src='img/Gender_FemaleOnly_18.png' title='Gender Preference' />";
                break;
            case enums.GenderPreferenceEnum.FemalePreferred:
                html += "<img src='img/Gender_Femalepreferred_18.png' title='Gender Preference' />";
                break;
            case enums.GenderPreferenceEnum.MaleOnly:
                html += "<img src='img/Gender_MaleOnly_18.png' title='Gender Preference' />";
                break;
            case enums.GenderPreferenceEnum.MalePreferred:
                html += "<img src='img/Gender_MalePreferred_18.png' title='Gender Preference' />";
                break;
            }

            return html;
        };

        function GetConfirmIndicator(confirmState) {
            var html = "<div class='confirm ";
            var colorClass;
            switch (confirmState) {
            case enums.ConfirmStateEnum.AwaitingResponse:
            case enums.ConfirmStateEnum.Left:
            case enums.ConfirmStateEnum.Queued:
                colorClass = "backOrange";
                break;
            case enums.ConfirmStateEnum.Confirmed:
                colorClass = "backGreen";
                break;
            case enums.ConfirmStateEnum.Unconfirmed:
                colorClass = "backRed";
                break;
            default:
                colorClass = "backGray";
                break;
            }
            html += colorClass + "'></div>";
            return html;
        };

        function WriteBlocks(response) {
            response.forEach(function(r) {
                var columnId = GetColumnId(r.date, r.employeeGlobalId);
                for (var i = 0; i < r.blocks.length; i++) {
                    var block = r.blocks[i];

                    var cell = GetCellByIds(r.date, block.startTime, r.employeeGlobalId);
                    // If block starts before book start time, display block at book start time
                    if (cell == null && moment(block.startTime, "hm").totalMinutes() < bookStartTime.totalMinutes()) {
                        cell = GetCellByIds(r.date, bookStartTime.format("h-m"), r.employeeGlobalId);
                    }

                    if (cell != null) {
                        var height = block.totalMinutes / $rootScope.appointmentBookIncrement * cellHeight;
                        var top = cell.top;

                        var id = block.appointBlockId;
                        var modBackColor = [255, 255, 255];
                        if (block.backgroundColorRgba != undefined) {
                            modBackColor = [block.backgroundColorRgba[0], block.backgroundColorRgba[1], block.backgroundColorRgba[2], .3];
                        }
                        var content = "<table style='background-color:rgba(0, 0, 0,.3); border:1.5px dashed " + getRgbaColor(block.backgroundColorRgba) + ";height:100%;width:100%;'><tr><td style='text-align:center;vertical-align:middle;font-size:14.667px;color:" + getRgbaColor(block.foregroundColorRgba) + "'>" + block.blockReason + "<td></tr></table>";
                        if (block.appointBlockDefinitionId != undefined) {
                            content += "<img class='blockDefIndicator' src='img/Appt_Standing_18.png' title='Block is part of a series' />";
                        }

                        WriteDiv({
                            Height: height,
                            Width: columnWidth,
                            Top: top,
                            ClassName: "standardCell draggable block",
                            Display: content,
                            Id: id,
                            ZIndex: zIndexBooking,
                            foregroundColor: block.foregroundColorRgba,
                            BackgroundColor: modBackColor,
                            addCss: "text-align: center;padding:3px",
                            container: "#" + columnId,
                            dataAttr: " data-type='" + blockDataTypeId + "' data-ip='" + block.includeInProductivity + "'" + " data-m='" + block.totalMinutes + "'"
                        });
                        WireUpBookingClicking(id, columnId);
                    }
                }
            });
        };

        function WireUpBookingClicking(id, currentAppointState) {

            $("#" + id).unbind("click").on("click", (function(e) {
                if (currentlyDraggableElement != undefined) {
                    try {
                        ($(currentlyDraggableElement).draggable("destroy"));
                    } catch (e) {
                        currentlyDraggableElement = undefined;
                    }
                }

                var type = $(this).data("type");
                if (!$scope.phoneMode && (type == blockDataTypeId || currentAppointState != enums.AppointStateEnum.CheckedOut)) {
                    MarkDraggable(id);
                }

                divCellHighlight.hide();
                divNewBooking.hide();
                divEditor.hide();
                divAppointmentDetails.hide();
                divBlockDetails.hide();

                var divDetails;
                if ($(this).data("type") == appointmentDataTypeId) {
                    if ($(e.target).hasClass("gap")) {
                        if (!$scope.phoneMode) {
                            showNewBooking(e);
                        }
                        return;
                    }
                    restServer.LoadAppointmentBookDetailPopup($(this).attr("id"), onAppointmentBookDetailPopupSuccess);
                    divDetails = divAppointmentDetails;
                } else {
                    restServer.LoadAppointmentBookBlockPopup($(this).attr("id"), onAppointmentBookBlockPopupSuccess);
                    divDetails = divBlockDetails;
                }
                positionPopup(divDetails, $(this), true);

                // Set position of highlighted cell to be used in double booking workflow
                var thisPosition = $(this).position();
                highlightedCell = GetCellByCoordinates(thisPosition.left, thisPosition.top, false);
                divCellHighlight.css("left", highlightedCell.left + timeColumnWidth).css("top", highlightedCell.top + headerOffset);
            })).dblclick(function() {
                var div = $(this);
                divAppointmentDetails.hide();
                divBlockDetails.hide();
                // TODO: Left and top needs to be based on available screen space.
                divEditor.css("left", div.position().left + parseInt(div.css("width")) + 10).css("top", div.position().top).show();
            });
        };

        function positionPopup(popupDiv, clickedDiv, offSet) {
            var win = $(window);
            var doc = $(document);

            var dialogDivHeight = popupDiv.height();
            var dialogDivWidth = popupDiv.width();

            var newLeft = clickedDiv.position().left + clickedDiv.width() + 10;
            var newTop = clickedDiv.position().top;
            if (offSet) {
                newLeft += timeColumnWidth;
                newTop += headerOffset;
            }

            if (newTop + dialogDivHeight > win.height() + doc.scrollTop()) {
                newTop = win.height() + doc.scrollTop() - dialogDivHeight - 10;
            }

            if (newLeft + dialogDivWidth - doc.scrollLeft() > win.width()) {
                newLeft = clickedDiv.position().left - dialogDivWidth - 10;
                if (offSet) {
                    newLeft += timeColumnWidth;
                }

                if (newLeft < 0) {
                    newLeft = 0;
                    if (offSet) {
                        newLeft += timeColumnWidth;
                    }
                }
            }

            popupDiv.css("left", newLeft).css("top", newTop).show();
        };

        function expandBook(newEndTime) {
            var startTime = moment(bookEndTime);
            // If the new end time goes into the next day, set the end time to the end of today
            if (newEndTime.date() > bookEndTime.date()) {
                newEndTime = moment("23:59", "h:m");
            }
            bookEndTime = newEndTime;
            writeTimeStructure(startTime, newEndTime);
        }

        function WriteSchedules(response) {
            var columnIds = [];
            response.forEach(function(r) {
                var columnId = GetColumnId(r.date, r.employeeGlobalId);

                columnIds.push(columnId);
                var columnMatches = _.where(columnBookings, { columnId: columnId });
                if (columnMatches.length > 0) {
                    var column = columnMatches[0];
                    column.bookableMinutes = 0;
                    column.hasBookableSchedule = false;
                    column.schedules = [];

                    // If schedules is empty, add an off work type schedule that takes up the entire day
                    if (r.schedules.length == 0) {
                        r.schedules.push({
                            workType: JSON.parse(JSON.stringify(businessInfo.offWorkType)),
                            startTime: bookStartTime.format('h-m'),
                            totalMinutes: (24 * 60) - bookStartTime.totalMinutes()
                        });
                    }

                    for (var i = 0; i < r.schedules.length; i++) {
                        var schedule = r.schedules[i];
                        column.schedules.push(schedule);
                        if (schedule.workType.isBookableTime) {
                            column.bookableMinutes += schedule.totalMinutes;
                        }

                        var startCell = GetCellByIds(r.date, schedule.startTime, r.employeeGlobalId);
                        var endCell;
                        if (schedule.endTime != undefined) {
                            endCell = GetCellByIds(r.date, schedule.endTime, r.employeeGlobalId);
                        }
                        var height = 0;
                        var display;

                        // Don't need to display anything for bookable schedules
                        if (schedule.workType.isBookableTime) {
                            height = schedule.totalMinutes / $rootScope.appointmentBookIncrement * cellHeight;
                            WriteDiv({
                                Height: height,
                                Width: columnWidth,
                                ClassName: "standarCellRel schedule",
                                ZIndex: zIndexSchedule,
                                container: "#" + columnId
                            });

                            var scheduleEndTime = moment(schedule.endTime, 'h-m');
                            if (scheduleEndTime > bookEndTime) {
                                expandBook(scheduleEndTime.add(1, "h"));
                            }

                            column.hasBookableSchedule = true;
                        } else {
                            display = schedule.workType.description.escapeHtml();
                            schedule.workType.style.backgroundColorRgba[3] = schedule.workType.style.backgroundColorRgba[3] * .7;
                            if (startCell != null) {
                                height = schedule.totalMinutes / $rootScope.appointmentBookIncrement * cellHeight;

                                WriteDiv({
                                    Height: height,
                                    Width: columnWidth,
                                    ClassName: "standarCellRel schedule",
                                    Display: display,
                                    ZIndex: zIndexSchedule,
                                    BackgroundColor: schedule.workType.style.backgroundColorRgba,
                                    foregroundColor: schedule.workType.style.foregroundColorRgba,
                                    addCss: "text-align: center;vertical-align: middle;line-height: " + height + "px",
                                    container: "#" + columnId
                                });
                            } else if (endCell != null) {
                                height = endCell.top;

                                WriteDiv({
                                    Height: height,
                                    Width: columnWidth,
                                    ClassName: "standarCellRel",
                                    Display: display,
                                    ZIndex: zIndexSchedule,
                                    BackgroundColor: schedule.workType.style.backgroundColorRgba,
                                    foregroundColor: schedule.workType.style.foregroundColorRgba,
                                    addCss: "text-align: center;vertical-align: middle;line-height: " + height + "px",
                                    container: "#" + columnId
                                });
                            }
                        }
                    }
                }
            });
            return columnIds;
        };

        function AdjustColumnsForMultiBooking(relatedColumnIds) {
            columnBookings.forEach(function(columnBooking) {
                if (relatedColumnIds.indexOf(columnBooking.columnId) >= 0) {
                    AdjustColumnCellsForMultiBooking(columnBooking.columnId);
                }
            });
        };

        function GetSortedBookings(columnId) {
            var bookings = [];
            $("#" + columnId).children(".appointment, .block").each(function() {
                var booking = $(this);

                bookings.push({
                    id: booking.attr("id"),
                    top: booking.position().top,
                    left: booking.position().left,
                    height: booking.height(),
                    width: booking.width(),
                    cellSharingBookings: [],
                    booking: booking
                });
            });
            return _.sortBy(bookings, function(booking) {
                return booking.top;
            });
        };

        function AdjustColumnCellsForMultiBooking(columnId) {
            var sortedBookings = GetSortedBookings(columnId);

            //Created copy of sorted list so that can iterate over both at the same time below
            var sortedBookings2 = _.sortBy(sortedBookings, function(booking) {
                return booking.top;
            });

            sortedBookings.forEach(function(mainBooking) {
                GetCellSharingBookings(mainBooking, sortedBookings2);
            });

            var alreadyConsidered = [];

            sortedBookings.forEach(function(booking) {
                var found = false;
                // Ignore any booking that's already been handled in a previous iteration
                alreadyConsidered.forEach(function(alreadyConsideredBooking) {
                    if (booking == alreadyConsideredBooking) {
                        found = true;
                    }
                });

                if (!found) {
                    var tempAlreadyConsidered = [];
                    tempAlreadyConsidered.push(booking);
                    // Gets list of all bookings that are adjacent to one another
                    GetAdjacentCells(booking, tempAlreadyConsidered);

                    // There's at least one booking related to this booking that overlap
                    if (tempAlreadyConsidered.length > 1) {
                        var newWidth = columnWidth / tempAlreadyConsidered.length;
                        var leftOffset = 0;
                        tempAlreadyConsidered.forEach(function(overlappingBooking) {
                            alreadyConsidered.push(overlappingBooking);
                            overlappingBooking.booking.css("left", "auto");
                            overlappingBooking.booking.css("width", newWidth).css("left", overlappingBooking.booking.position().left + leftOffset);
                            leftOffset += newWidth;
                        });
                    } else {
                        // If there's no related booking, make sure booking is at defaults.  This case would
                        // apply in a drag/drop scenario
                        var outerPadding = (parseInt(booking.booking.css("padding-left")) + parseInt(booking.booking.css("border-left-width"))) * 2;
                        booking.booking.width(columnWidth - outerPadding);
                        booking.booking.css("left", "auto");
                        alreadyConsidered.push(tempAlreadyConsidered[0]);
                    }
                }
            });

        };

        function GetCellSharingBookings(mainBooking, sortedBookingToCheck) {
            mainBooking.cellSharingBookings = [];
            for (var i = 0; i < sortedBookingToCheck.length; i++) {
                var potentialShare = sortedBookingToCheck[i];
                // Can ignore any bookings that are before main booking
                if (mainBooking.id == potentialShare.id || potentialShare.top + potentialShare.height <= mainBooking.top) {
                    continue;
                } else if (potentialShare.top >= mainBooking.top + mainBooking.height) {
                    // Have passed main booking so can ignore the rest
                    break;
                } else {
                    mainBooking.cellSharingBookings.push(potentialShare);
                }
            }
        };

        function GetAdjacentCells(booking, alreadyConsidered) {
            var unconsidered = [];

            booking.cellSharingBookings.forEach(function(cellSharingBooking) {
                var found = false;
                alreadyConsidered.forEach(function(alreadyConsideredBooking) {

                    if (cellSharingBooking == alreadyConsideredBooking) {
                        found = true;
                    }
                });
                if (!found) {
                    alreadyConsidered.push(cellSharingBooking);
                    unconsidered.push(cellSharingBooking);
                }
            });

            if (unconsidered.length > 0) {
                unconsidered.forEach(function(unconsideredBook) {
                    GetAdjacentCells(unconsideredBook, alreadyConsidered);
                });
            }
        };

        function GetColumnId(startDate, employeeGlobalId) {
            return replaceAll(startDate, "/", "-") + "_" + employeeGlobalId.replaceAll("-", "");
        };

        function MakeDimensionDataRequest() {

            var employeeIds = [];
            var dates = [];
            for (var i = lastRequestedDimension; i < lastRequestedDimension + numberOfDimensionsPerRequest; i++) {
                if (i >= columnBookings.length) {
                    break;
                }
                dates.push(columnBookings[i].date);
                employeeIds.push(columnBookings[i].employeeId);
            }
            if (dates.length > 0) {
                restServer.LoadAppointmentBookData(dates, employeeIds, onApptBookDataSuccess);
            } else {
                // Remove all columns that were marked to be removed
                for (var j = columnBookings.length - 1; j >= 0; j--) {
                    if (columnBookings[j].remove != undefined && columnBookings[j].remove) {
                        $(columnBookings[j]).remove();
                    }
                }
            }
            lastRequestedDimension += numberOfDimensionsPerRequest;
        };

        function writeTimeStructure(startTime, endTime) {
            var intervals = 0;
            var startHour = startTime.hours();
            var startMin = startTime.minutes();
            var endHour = endTime.hours();
            var endMin = endTime.minutes();
            // Write time column
            while (startHour <= endHour) {

                for (var currentIntervalMin = startMin; currentIntervalMin < 60; currentIntervalMin = currentIntervalMin + $rootScope.appointmentBookIncrement) {
                    if (startHour == endHour && currentIntervalMin == endMin) {
                        break;
                    }

                    var backgroundColorClass = "timeGray";
                    if (currentIntervalMin == 0) {
                        backgroundColorClass = "timePurple";
                    }
                    var minutes = startHour * 60 + currentIntervalMin;

                    WriteDiv({
                        Height: cellHeight,
                        Width: timeColumnWidth,
                        Left: 0,
                        Top: $("#divTimeContainer").height() + headerOffset,
                        ClassName: "standardCellTime " + backgroundColorClass,
                        Display: GetTimeDisplay(startHour, currentIntervalMin),
                        ZIndex: zIndexTime,
                        container: $("#divTimeContainer")
                    });

                    backgroundColorClass = "";
                    if (currentIntervalMin == 0) {
                        backgroundColorClass = "major";
                    }
                    WriteDiv({
                        Height: cellHeight,
                        ClassName: "row " + backgroundColorClass,
                        container: "#divRows",
                        Id: GenerateRowId(startHour, currentIntervalMin),
                        dataAttr: " data-min='" + minutes + "'"
                    });
                    intervals++;
                    startMin = 0;
                }
                startHour++;
            }
            $("#divColumns").css("height", $("#divTimeContainer").height());

            $(".standardCellTime").on("click", function() {
                var cell = $(this);
                var childOffsetInParent = cell.offset().top - cell.parent().offset().top;
                $("body").scrollTop(childOffsetInParent);
            });
            return intervals;
        }

        function WriteStructure(response) {
            BuildColumns(response);
            MakeDimensionDataRequest();

            // Subtract one hour from earliest opening time and add one hour to latest closing time
            bookStartTime = moment(businessInfo.earliestOpening, "h:m").add(-1, "h");
            bookEndTime = moment(businessInfo.latestClosing, "h:m").add(1, "h");


            // Wanted to dynamically use outerHeight but sometimes that returns null probably b/c its a directive and angular hasn't processed it yet
            headerMargin = filterBarHeight; // $("#divApptBookHeader").outerHeight();
            headerOffset = cellHeight * 2 + headerMargin;
            var left = 0;
            var top = 0;

            var divTimeContainer = $("#divTimeContainer");
            // Write top left cell which is a spacer between time column and header rows
            WriteDiv({
                Top: headerMargin,
                Height: headerOffset - headerMargin,
                Width: timeColumnWidth,
                ClassName: "standardCellTopLeft",
                ZIndex: 1001
            });

            top += headerOffset;
            columnRight = timeColumnWidth + (columnBookings.length * columnWidth);

            var intervals = writeTimeStructure(bookStartTime, bookEndTime, top);
            var columnBottom = (intervals) * cellHeight;

            left += timeColumnWidth;
            // Write first row of headers
            parentColumns.forEach(function(parentColumn) {
                top = 0;
                var width = columnWidth * parentColumn.innerDimensions.length;
                WriteDiv({
                    Width: width,
                    Id: parentColumn.divId,
                    ClassName: "headerCellRoot",
                    Display: "<span " + injectEmployeeIdDataAttr(parentColumn) + ">" + getHeaderText(parentColumn) + "</span>",
                    container: "#divRootHeaders"
                });
                writeGenderIcon(parentColumn.divId, parentColumn);
                left += width;
            });

            left = 0;
            columnBookings.forEach(function(childColumn) {
                top = cellHeight;
                //Write column header
                var columndId = "Header" + childColumn.columnId;

                WriteDiv({
                    Width: columnWidth,
                    ClassName: "headerCell",
                    Id: columndId,
                    foregroundColor: childColumn.foregroundColor,
                    BackgroundColor: childColumn.backgroundColor,
                    Display: "<div class='headerBar'></div><div class='headerCellText'" + injectEmployeeIdDataAttr(childColumn) + ">" + getHeaderText(childColumn) + "</div>",
                    ZIndex: zIndexStructure,
                    container: "#divHeaders"
                });
                writeGenderIcon(columndId, childColumn);
                top += cellHeight;

                WriteDiv({
                    Width: columnWidth,
                    Id: childColumn.columnId,
                    ClassName: "column",
                    container: "#divColumns"
                });

                $("#" + childColumn.columnId).data("rootHeaderId", childColumn.rootHeaderId);
                left += columnWidth;

            });

            SetupDivs();
            WireUpEmptyCellClick(columnRight, columnBottom);

            divTimeContainer.css({ "margin-top": headerOffset, "width": timeColumnWidth, "z-index": zIndexTime });
            $("#divRootHeaders").css("left", timeColumnWidth).css("top", headerMargin).css("height", cellHeight);
            $("#divHeaders").css("left", timeColumnWidth).css("top", cellHeight + headerMargin).css("height", cellHeight);
            $("#divColumns").css("left", timeColumnWidth).css("top", headerOffset);
            $("#divRows").css("left", timeColumnWidth).css("top", headerOffset).css("width", columnRight - timeColumnWidth);
            $("#divCurrentTimeBar").css("height", cellHeight);
            $("#divCutCopy").css("top", headerMargin);

        };

        function getHeaderText(column) {
            var headerText;
            if (column.dimensionType === "DATE") {
                headerText = dateTime(moment(column.headerText, "M/D/YYYY").format(), "date");
            } else {
                headerText = column.headerText;
            }
            return headerText;
        }
        var previousWindowWidth = 0;

        function detectPhoneMode() {
            defaultEmployeeIds = [];
            previousWindowWidth = $(window).width();
            if (device.mobile()) {
                columnWidth = $(window).width() - timeColumnWidth;
                var employeeGlobalId = localStorage.getItem('userEmployee'); //getHashValue("employeeGlobalId");
                if (employeeGlobalId != null) {
                    defaultEmployeeIds.push(employeeGlobalId);
                } else { // If in phone mode, but employee id not passed in url, add dummy id so that no employees are displayed
                    defaultEmployeeIds.push(NewGuid());
                }
                $scope.phoneMode = true;
            } else {
                columnWidth = 200;
                $scope.phoneMode = false;
            }
        }

        var scrollTop = 0;
        var scrollLeft = 0;

        function scroll() {
            // One or both will not be 0 only when showing a popup in position fixed mode
            if (scrollTop == 0 && scrollLeft == 0) {
                // When scrolling need to manually position top of timecontainer since we want it to be fixed horizontally, but scroll vertically.
                $('.fixedColumn').css({
                    'top': $(this).scrollTop() * -1
                });
                // Need to manually position left of header containers since they need to be fixed vertically, but scroll horizontally
                $("#divRootHeaders").css('left', $(this).scrollLeft() * -1 + timeColumnWidth);
                $("#divHeaders").css('left', $(this).scrollLeft() * -1 + timeColumnWidth);
            } else {
//                // Since position fixed, scroll position of body gets set to 0 by browser so in order to give the appearence of maintaining scroll position
//                // need to reposition left and top of containers based on capture scroll position
//                $('.fixedColumn').css({'top': scrollTop*-1});
//                $("#divColumns").css({ "top": $("#divColumns").position().top - scrollTop, "left": $("#divColumns").position().left - scrollLeft });
//                $("#divRows").css({ "top": $("#divRows").position().top - scrollTop, "left": $("#divRows").position().left - scrollLeft });
//                $("#divRootHeaders").css('left', scrollLeft*-1 +timeColumnWidth);
//                $("#divHeaders").css('left', scrollLeft*-1 +timeColumnWidth);
//                // Unhook scroll events b/c not needed in fixed position and these prevents any scrolling abnormalities that appear to happen in ios when in fixed position
//                $(document).off("scroll");
//                $(document).off("touchmove");
            }
        }

        var popupCount = 0;

        function showPopup(popupId) {
            if (popupCount == 0) {
                console.log('show');
                // capture scroll positions which will be used in scroll method which will automatically get called when setting position to fixed on body
                // b/c that sets scroll position to 0;
                scrollTop = $("body").scrollTop();
                scrollLeft = $("body").scrollLeft();
//            console.log("sfsd" + $("#divContainer").scrollTop());

                // need to do this b/c ios repositions popups sporadically when setting focus to controls within popups
                //            $("body").css("position", "fixed");

//            $("body").css("overflow", "hidden");
//            $("body").scrollTop(0).scrollLeft(0);
//            $("#divContainer").scrollTop(0).scrollLeft(0);
                //console.log("width" + $("window").height());

                var containerWidth = $("#divRows").position().left + $("#divRows").width();
                var containerHeight = $("#divRows").position().top + $("#divRows").height();
                $("#divContainer").css({ position: "relative", "height": $(window).height(), "width": $(window).width() });
                $('.fixedColumn').css({
                    'top': 0
                });
//                        $("body").css("overflow", "hidden");
//            $("body").css("overflow", "hidden");
            }
//        $(popupId).css("top", $(window).scrollTop()).css("left", $(window).scrollLeft());
            $(popupId).show();
            popupCount++;
        }

        function hidePopup(popupId) {
            var popup = $(popupId);
            if (popup.is(":hidden")) {
                return;
            }
            popup.hide();
            popupCount--;

            if (popupCount == 0) {
                console.log('hide');
                $("#divContainer").css({ position: "static", "height": "0", "width": "0" });
                $("body").scrollTop(scrollTop).scrollLeft(scrollLeft);

                // This works for both scrollTop and scrollLeft, but not at the same time. It cancels out the other one when the next one fires.
                //$('html, body').animate({
                //    'scrollTop': scrollTop
                //}, 0);

//                $("#divColumns").css({ "top": scrollTop, "left": scrollLeft });
//                $("#divContainer").css({"top":0});
//                $("body").css("overflow", "scroll");
//                // set back to relative b/c don't need to freeze scrolling to prevent ios positioning issues anymore
//                $("body").css("position", "relative");
//
//                // reset default positions of containers and the scroll positions prior to showing popup
//                $(".fixedColumn").css("top", "0");
//                $("body").scrollTop(scrollTop).scrollLeft(scrollLeft);
//                $("#divColumns").css({ "top": headerOffset, "left": timeColumnWidth });
//                $("#divRows").css({ "top": headerOffset, "left": timeColumnWidth });
//                $("#divRootHeaders").css('left', timeColumnWidth);
//                $("#divHeaders").css('left', timeColumnWidth);
                scrollTop = 0;
                scrollLeft = 0;
//                $(document).on("touchmove", scroll);
//                $(document).on("scroll", scroll);
            }
        }

        function injectEmployeeIdDataAttr(column) {
            var employeeIdDataAttr = '';
            if (column.dimensionType == "EMPLOYEE") {
                employeeIdDataAttr = ' data-employeeid="' + column.employeeId + '"';
            }
            return employeeIdDataAttr;
        }

        function writeGenderIcon(id, column) {
            if (column.dimensionType == "EMPLOYEE") {
                var imageUrl = "";
                switch (column.genderEnum) {
                case enums.GenderEnum.Female:
                    imageUrl = "img/EmpGender_Female_20.png";
                    break;
                case enums.GenderEnum.Male:
                    imageUrl = "img/EmpGender_Male_20.png";
                    break;
                }
                if (imageUrl != "") {
                    $("#" + id).prepend("<img src='" + imageUrl + "'/>");
                }
            }
        };

        function SetupDivs() {
            divNewBooking = $("#divNewBooking").css("z-index", zIndexPopup);
            divAppointmentDetails = $("#divAppointmentDetails").css("z-index", zIndexPopup);
            divBlockDetails = $("#divBlockDetails").css("z-index", zIndexPopup);
            divEditor = $("#divEditor").css("z-index", zIndexPopup);
            divCellHighlight = $("#divCellHighlight").css("z-index", zIndexCellHighlight);
            wireUpEmployeeHeaderClick();
        };

        function wireUpEmployeeHeaderClick() {
            // Employee name can be at root header or sub column header depending on column ordering so need to handle clicking of both
            $(".headerCellText, .headerCellRoot span").parent().on("click", function() {
                var employeeId = $(this).find(".headerCellText, span").data("employeeid");
                if (employeeId) {
                    $scope.updateFilters([], [{ id: employeeId }], []);
                    $scope.selectWeek();
                    $rootScope.$broadcast("addEmployeeFilter", { employeeId: employeeId });
                }
            });
        }

        function WireUpEmptyCellClick(right, bottom) {


            divCellHighlight.css("width", columnWidth).css("height", cellHeight);
            var divClickOverlay = $("#divClickOverlay").css("z-index", zIndexClick);
            divClickOverlay.css("width", right - timeColumnWidth).css("height", bottom).css("left", timeColumnWidth).css("top", headerOffset);
            divClickOverlay.unbind().click(function(e) {
                if ($scope.phoneMode) {
                    return;
                }
                divEditor.hide();
                divAppointmentDetails.hide();
                divBlockDetails.hide();

                if (copyCutAppointDetailId == undefined) {
                    showNewBooking(e);
                } else {
                    var cell = GetCellByCoordinates(e.pageX, e.pageY, true);
                    var nextCopyId;
                    var copyCutAppointDetail = $("#" + copyCutAppointDetailId);
                    // if just a copy, need to make a clone of div to replace the one being moved
                    if (copyCutAppointDetail.data("cutId") == undefined) {
                        nextCopyId = CopyAppointDetail(copyCutAppointDetail);
                    }
                    CopyCutMove(copyCutAppointDetail, cell, { top: copyCutAppointDetail.position().top, left: copyCutAppointDetail.position().left });
                    copyCutAppointDetailId = nextCopyId;
                }
            });
        };

        function showNewBooking(e) {
            var cell = GetCellByCoordinates(e.pageX, e.pageY, true);
            highlightedCell = cell;


            var actualLeft = cell.left + timeColumnWidth;
            var actualTop = cell.top + headerOffset;
            divCellHighlight.css("left", actualLeft).css("top", actualTop).show();

            positionPopup(divNewBooking, divCellHighlight, false);
        }

        function GenerateRowId(hour, interval) {
            var id;

            if (interval == 0) {
                id = hour + "-0";
            } else {
                id = hour + "-" + interval;
            }
            return id;
        };

        function BuildColumns(response) {
            columnBookings = [];
            parentColumns = _.filter(response.innerDimensions, function(parentColumn) {
                return parentColumn.innerDimensions.length > 0;
            });
            var canViewAll = security.getSecurityAttr(security.keys.viewAll).canWrite();
            for (var i = 0; i < parentColumns.length; i++) {
                var firstDimension = parentColumns[i];
                firstDimension.divId = i;
                for (var j = 0; j < firstDimension.innerDimensions.length; j++) {
                    var allowBooking;
                    var childDimension = firstDimension.innerDimensions[j];
                    var date;
                    var employeeId;
                    var genderEnum;
                    var employeeName;
                    if (childDimension.dimensionType == "EMPLOYEE") {
                        date = firstDimension.id;
                        employeeId = childDimension.id;
                        employeeName = childDimension.headerText;
                        allowBooking = childDimension.allowBooking;
                        childDimension.id = GetColumnId(firstDimension.id, childDimension.id);
                        genderEnum = childDimension.genderEnum;
                    } else {
                        date = childDimension.id;
                        employeeId = firstDimension.id;
                        employeeName = firstDimension.headerText;
                        allowBooking = firstDimension.allowBooking;
                        childDimension.id = GetColumnId(childDimension.id, firstDimension.id);
                    }

                    if (canViewAll || employeeId == localStorage.getItem('userEmployee')) {
                        columnBookings.push({
                            date: date,
                            rootHeaderId: firstDimension.divId,
                            foregroundColor: childDimension.foregroundColor,
                            backgroundColor: childDimension.backgroundColor,
                            hasBookableSchedule: false,
                            employeeId: employeeId,
                            allowBooking: allowBooking,
                            columnId: childDimension.id,
                            employeeName: employeeName,
                            headerText: childDimension.headerText,
                            dimensionType: childDimension.dimensionType,
                            genderEnum: genderEnum,
                            schedules: [],
                            bookableMinutes: 0
                        });
                    }
                }
            }

        };

        function GetTimeDisplay(tempStartHour, currentInterval) {
            var display = '';

            if ($rootScope.isAmPmTime) {
                var suffix;
                if (tempStartHour > 12) {
                    display += tempStartHour - 12;
                } else {
                    display += tempStartHour;
                }
                if (tempStartHour >= 12) {
                    suffix = "PM";
                } else {
                    suffix = "AM";
                }
                if (currentInterval != 0) {
                    display += ':' + currentInterval;
                    suffix = suffix.substring(0, 1);
                } else {
                    display += ' ';
                }
                display += suffix;
            } else {
                display = tempStartHour + ":" + currentInterval;
                if (currentInterval == 0) {
                    display += "0";
                }
            }
            return display;
        };

        function WriteDiv(data) {
            var divHtml = "<div";
            if (data.Id != undefined) {
                divHtml += " id=" + data.Id;
            }

            if (data.dataAttr != undefined) {
                divHtml += data.dataAttr;
            }

            divHtml += " class='" + data.ClassName + "' style='";

            if (data.Height != undefined) {
                divHtml += "height:" + data.Height + "px";
            }
            if (data.ZIndex != undefined) {
                divHtml += ";z-index:" + data.ZIndex;
            }
            if (data.Width != undefined) {
                divHtml += ";width:" + data.Width + "px";
            }
            if (data.Top != undefined) {
                divHtml += ";top:" + data.Top + "px";
            }
            if (data.Left != undefined) {
                divHtml += ";left:" + data.Left + "px";
            }

            if (data.BackgroundColor != undefined) {
                divHtml += ";background-color: " + getRgbaColor(data.BackgroundColor);
            }

            if (data.foregroundColor != undefined) {
                divHtml += ";color: " + getRgbaColor(data.foregroundColor);
            }

            if (data.addCss != undefined) {
                divHtml += ";" + data.addCss;
            }

            var display = '';
            if (data.Display != undefined) {
                display = data.Display;
            }
            divHtml += "'>" + display + "</div>";

            if (data.container != undefined) {
                $(data.container).append(divHtml);
            } else {
                $("#divContainer").append(divHtml);
            }

        };

        function showMessage(message, config) {
            if (config == undefined) {
                config = {};
            }

            if (config.buttonsType == undefined) {
                config.buttonsType = enums.ButtonTypeEnum.Ok;
            }
            if (config.hidePopupOnButtonClick == undefined) {
                config.hidePopupOnButtonClick = true;
            }
            if (config.messageClass == undefined) {
                $("#divMessageContainer").removeClass("high").addClass("normal");
            } else {
                $("#divMessageContainer").removeClass("high").addClass(config.messageClass);
            }
            $("#divMessageTemplate").children().hide();
            if (config.customTemplateId != undefined) {
                $("#" + config.customTemplateId).show();
            } else {
                $("#divMessage").show();
            }
            messageConfig = config;
            $("#btnMessageDialogCancel").hide();
            $("#btnMessageDialogOk").hide();
            $("#btnMessageDialogYes").hide();
            $("#btnMessageDialogNo").hide();
            switch (config.buttonsType) {
            case enums.ButtonTypeEnum.Ok:
                $("#btnMessageDialogOk").show();
                break;
            case enums.ButtonTypeEnum.OkCancel:
                $("#btnMessageDialogOk").show();
                $("#btnMessageDialogCancel").show();
                break;
            case enums.ButtonTypeEnum.YesNo:
                $("#btnMessageDialogYes").show();
                $("#btnMessageDialogNo").show();
                break;
            }
            $("#divMessage").html(message);
            showPopup("#divDialogMessage");
        };

        function CutCopy() {
            var container = $("#divCutCopyDetails");

            if (_.where(cutCopyIds, { appointDetailId: $scope.details.appointDetailId }).length > 0) {
                $("#divAppointmentDetails").hide();
                return;
            }

            var clone = $("#" + $scope.details.appointDetailId).clone();
            if (isCutting) {
                clone.data("cutId", $scope.details.appointDetailId);
                $("#" + $scope.details.appointDetailId + "Overlay").show();
            } else {
                clone.data("copyId", $scope.details.appointDetailId);
            }

            var padding = 10;
            var headerSpacing = 15;
            var newId = NewGuid();
            clone.attr("id", newId).css({ top: padding / 2 + headerSpacing, left: padding / 2, width: columnWidth });
            cutCopyIds.push({ id: newId, appointDetailId: $scope.details.appointDetailId });

            var height = clone.height() + padding + headerSpacing;
            var width = clone.width() + padding;
            var parentDiv = clone.wrap("<div class='cutcopyWrapper' style='position:relative;margin:10px;height:" + height + "px;width:" + width + "px;'>" +
                "</div>").parent();
            parentDiv.prepend("<div class='clipboardleft'>" + $scope.details.employeeCode + "</div>");
            parentDiv.prepend("<div class='clipboardright'>" + dateTime($scope.details.startDate, 'date') + ' ' + dateTime($scope.details.startTime, 'time') + "</div>");
            parentDiv.appendTo(container);

            $(".cutcopyWrapper").unbind().click(function() {
                $(".cutcopyWrapper").removeClass("divSelected");
                $(this).addClass("divSelected");
                copyCutAppointDetailId = $(this).find(".appointment").attr("id");
            });
            $("#divCutCopy").show();
            $("#divAppointmentDetails").hide();
            MarkDraggable();
        };


        function filterBook() {
            $("body").scrollTop(0).scrollLeft(0);
            if (dateType == enums.AppointmentBookDateTypeFilter.Day) {
                dates = [$scope.dateString];
            } else {
                var startDayOfWeek;
                var startDayOfWeekSetting = $scope.getSetting(enums.SettingEnum.StartAppointmentBookDayOn);
                switch (parseInt(startDayOfWeekSetting)) {
                case enums.WeekdayNameEnum.Sunday:
                    startDayOfWeek = 0;
                    break;
                case enums.WeekdayNameEnum.Monday:
                    startDayOfWeek = 1;
                    break;
                case enums.WeekdayNameEnum.Tuesday:
                    startDayOfWeek = 2;
                    break;
                case enums.WeekdayNameEnum.Wednesday:
                    startDayOfWeek = 3;
                    break;
                case enums.WeekdayNameEnum.Thursday:
                    startDayOfWeek = 4;
                    break;
                case enums.WeekdayNameEnum.Friday:
                    startDayOfWeek = 5;
                    break;
                case enums.WeekdayNameEnum.Saturday:
                    startDayOfWeek = 6;
                    break;
                }

                dates = [];
                var temp = moment($scope.dateString);
                temp.day(startDayOfWeek);
                if (temp > moment($scope.dateString)) {
                    temp.add(-7, "d");
                }
                for (var j = 0; j < 7; j++) {
                    dates.push(temp.format());
                    temp.add(1, "d");
                }
            }

            var employeeIds = [];
            var serviceIds = [];
            var jobFunctionIds = [];

            if (isObject($scope.filteredJobFunctions)) {
                for (var i = 0; i < $scope.filteredJobFunctions.length; i++) {
                    if ($scope.filteredJobFunctions[i] != undefined && $scope.filteredJobFunctions[i].id != undefined) {
                        jobFunctionIds.push($scope.filteredJobFunctions[i].id);
                    }
                }
            }

            if (isObject($scope.filteredEmployees)) {
                for (var i = 0; i < $scope.filteredEmployees.length; i++) {
                    if ($scope.filteredEmployees[i] != undefined && $scope.filteredEmployees[i].id != undefined) {
                        employeeIds.push($scope.filteredEmployees[i].id);
                    }
                }
            }

            if (isObject($scope.filteredServices)) {
                for (var i = 0; i < $scope.filteredServices.length; i++) {
                    if ($scope.filteredServices[i] != undefined && $scope.filteredServices[i].id != undefined) {
                        serviceIds.push($scope.filteredServices[i].id);
                    }
                }
            }

            if ($scope.phoneMode) {
                employeeIds = defaultEmployeeIds;
            }

            divAppointmentDetails.hide();
            divBlockDetails.hide();
            divCellHighlight.hide();
            divNewBooking.hide();
            $("#divRootHeaders").empty();
            $("#divHeaders").empty();
            $("#divRows").empty();
            $("#divColumns").empty();
            $("#divTimeContainer").empty();
            lastRequestedDimension = 0;

            restServer.LoadAppointmentBookStructure(dates, jobFunctionIds, employeeIds, serviceIds).then(function(result) {
                onApptBookStructureSuccess(result.data);
            });
        };


        function showEditor(type) {
            divNewBooking.hide();
            divCellHighlight.hide();
            var employeeName = _.where(columnBookings, { columnId: GetColumnId(highlightedCell.date, highlightedCell.employeeGlobalId) })[0].employeeName;

            var data = {
                startTime: highlightedCell.time,
                date: highlightedCell.date,
                employee: {
                    id: highlightedCell.employeeGlobalId,
                    displayName: employeeName
                }
            };

            if (type == appointmentDataTypeId) {
                $rootScope.$broadcast("newAppointment", data);
                $scope.appointmentEditorLocation = appointmentEditorLocation;
                showPopup("#divDialogAppointmentEditor");
            } else {
                $rootScope.$broadcast("newBlock", data);
                $scope.blockEditorLocation = blockEditorLocation;
                showPopup("#divDialogBlockEditor");
            }
        }

        function refreshColumnForSave(columnId) {
            var column = _.where(columnBookings, { columnId: columnId })[0];
            $("#" + columnId).empty();
            restServer.LoadAppointmentBookData([column.date], [column.employeeId], onApptBookDataSuccess);
        }

        function refreshColumnsForSave(affectedColumns) {
            var columnIds = [];
            var dates = [];
            var employeeGlobalIds = [];
            affectedColumns.forEach(function(affectedColumn) {
                var date = affectedColumn.date.format("M-D-YYYY");
                var columnId = GetColumnId(date, affectedColumn.employeeGlobalId);
                if (columnIds.indexOf(columnId) == -1) {
                    if (_.where(columnBookings, { columnId: columnId }).length > 0) {
                        $("#" + columnId).empty();
                        dates.push(date);
                        employeeGlobalIds.push(affectedColumn.employeeGlobalId);
                    }
                    columnIds.push(columnId);
                }
            });
            if (dates.length > 0) {
                restServer.LoadAppointmentBookData(dates, employeeGlobalIds, onApptBookDataSuccess);
            }
        }

        // Whenever getting coordinates for a cell, those coordinates are relative to the divRows and divCells containers so they don't include the offset for the time column or header
        function GetCellByIds(date, time, employeeId) {
            var columnId = GetColumnId(date, employeeId);

            var cell = {};

            var divColumns = $(".column");
            for (var j = 0; j < divColumns.length; j++) {
                var column = $(divColumns[j]);
                if (column.attr("id") == columnId) {
                    cell.left = column.position().left;
                    break;
                }
            }

            var divRows = $(".row");
            for (var i = 0; i < divRows.length; i++) {
                var row = $(divRows[i]);
                if (row.attr("id") == time) {
                    cell.top = row.position().top;
                    break;
                }
            }

            if (cell.left == undefined || cell.top == undefined) {
                return null;
            } else {
                return cell;
            }
        };

        // Whenever getting coordinates for a cell, those coordinates are relative to the divRows and divCells containers so they don't include the offset for the time column or header
        function GetCellByCoordinates(x, y, considerOffsets) {
            var realy = y;
            var realx = x;
            if (considerOffsets) {
                realy = y - headerOffset;
                realx = x - timeColumnWidth;
            }
            var cell = {};

            var divColumns = $(".column");
            for (var j = 0; j < divColumns.length; j++) {
                var column = $(divColumns[j]);
                var left = column.position().left;
                if (realx >= left && realx <= left + column.width()) {
                    cell.left = left;
                    cell.columnId = column.attr("id");
                    cell.date = cell.columnId.split("_")[0];
                    cell.employeeGlobalId = cell.columnId.split("_")[1];
                    break;
                }
            }

            var divRows = $(".row");
            for (var i = 0; i < divRows.length; i++) {
                var row = $(divRows[i]);
                var top = row.position().top;
                if (realy >= top && realy <= top + row.height()) {
                    cell.top = top;
                    cell.time = row.attr("id").replace("-", ":");
                    cell.startMinutes = row.data("min");
                    break;
                }
            }

            if (cell.left == undefined || cell.top == undefined) {
                return null;
            } else {
                return cell;
            }
        };

        function hideAppointmentEditor() {
            hidePopup("#divDialogAppointmentEditor");
        };

        function hideBlockEditor() {
            hidePopup("#divDialogBlockEditor");
        };

        var timeBarTimeOutId;

        function setCurrentTimeBarPosition() {
            var top = Math.floor((moment().totalMinutes() - bookStartTime.totalMinutes()) / $rootScope.appointmentBookIncrement) * cellHeight;
            $(".divCurrentTimeBar").css("top", top);
            clearTimeout(timeBarTimeOutId);
            timeBarTimeOutId = setTimeout(setCurrentTimeBarPosition, 60000); // wait a minute before calling again
        }


        function editStanding(appointStandingDefinitionId) {
            $rootScope.$broadcast("editStanding", { appointStandingDefinitionId: appointStandingDefinitionId });
            $scope.openStandingEditor();
        }

        function editAppointment(details) {
            $rootScope.$broadcast("editAppointment", { appointDetailId: details.appointDetailId });
            $scope.appointmentEditorLocation = appointmentEditorLocation;
            showPopup("#divDialogAppointmentEditor");
        }

        function editBlock(blockId) {
            $rootScope.$broadcast("editBlock", { blockId: blockId });
            $scope.blockEditorLocation = blockEditorLocation;
            showPopup("#divDialogBlockEditor");
        }

        function editBlockDefinition(blockDefinitionId) {
            $rootScope.$broadcast("editBlockDefinition", { appointBlockDefitionId: blockDefinitionId });
            $scope.openBlockDefinitionEditor();
        }

        function lock(noun, entityId, lockSuccessCallback) {
            restServer.addLock(entityId, noun, function(response) {
                if (response.lockedBy != undefined) {
                    showMessage(response.lockedBy);
                } else {
                    lockSuccessCallback();
                }

            });
        }

        //#endregion

        //#region On Success & Errors

        var onApptBookDataSuccess = function(response) {
            MakeDimensionDataRequest();
            var relatedColumnIds = WriteSchedules(response);
            WriteAppointments(response);
            WriteBlocks(response);

            CheckColumnHiding(relatedColumnIds);
            AdjustColumnsForMultiBooking(relatedColumnIds);
            CalculatePercentageBooked(relatedColumnIds);

            relatedColumnIds.forEach(function(columnId) {
                var column = _.where(columnBookings, { columnId: columnId })[0];
                if (moment(column.date, columnDateFormat).format(columnDateFormat) === moment().format(columnDateFormat)) {
                    WriteDiv({ ClassName: 'divCurrentTimeBar', container: "#" + column.columnId, Height: cellHeight, Width: columnWidth });
                }
            });
            setCurrentTimeBarPosition();
        };

        var onMoveAppointDetailSuccess = function(response) {
            if (response.lockedBy != undefined) {
                copyCutMoveRevert();
                showMessage(response.lockedBy);
            } else if (response.warnings != undefined) {
                $rootScope.$broadcast("showMessage", { message: response.warnings, buttonsType: enums.ButtonTypeEnum.YesNo, callback: checkWarningCallback });
            } else {
                $scope.setAppointStateIndicator(response.appointDetail.appointDetailId, response.appointDetail.currentAppointStateEnum);
                copyCutMoveBooking.removeData("cutId");
            }
        };

        var onCopyAppointDetailSuccess = function(response) {
            if (response.warnings != undefined) {
                $rootScope.$broadcast("showMessage", { message: response.warnings, buttonsType: enums.ButtonTypeEnum.YesNo, callback: checkWarningCallback });
            } else {
                copyCutMoveBooking.removeData("copyId");
            }
        }

        function checkWarningCallback(result) {
            if (result == enums.MessageBoxButtonResult.Yes) {
                copyCutMoveBookingServerCall(true);
            } else {
                copyCutMoveRevert();
            }
        }

        var onAppointmentBookDetailPopupSuccess = function(response) {
            $scope.details = response;
        };

        var onAppointmentBookBlockPopupSuccess = function(response) {
            response.showSingleDeleteMessage = true;
            $scope.block = response;
        };

        var onDeleteAppointDetailsSuccess = function(response) {
            deletedIds.forEach(function(id) {
                var deletedDiv = $("#" + id);
                if (deletedDiv.length > 0) {
                    var columnId = deletedDiv.parent().attr("id");
                    deletedDiv.remove();
                    CalculatePercentageBookedForColumnId(columnId);
                    AdjustColumnCellsForMultiBooking(columnId);
                }
            });
            hidePopup("#divDialogDelete");
            hidePopup("#divDialogAppointmentEditor");
        };

        var onDeleteAppointBlockSuccess = function(response) {
            var deletedDiv = $("#" + $scope.block.appointBlockId);
            var columnId = deletedDiv.parent().attr("id");
            deletedDiv.remove();
            AdjustColumnCellsForMultiBooking(columnId);
        };

        var onChangeAppointDetailStateSuccess = function(response) {
            $scope.setAppointStateIndicator($scope.details.appointDetailId, $scope.details.currentAppointStateEnum);
            if ($scope.details.currentAppointStateEnum == enums.AppointStateEnum.CheckedIn) {
                if (response.siblingAppointDetailsToCheckIn.length > 0) {
                    showMessage("Do you want to check in all services for this client?", {
                        buttonsType: enums.ButtonTypeEnum.YesNo,
                        callback: function(messageResult) {
                            if (messageResult == enums.MessageBoxButtonResult.Yes) {
                                restServer.changeAppointDetailsState(response.siblingAppointDetailsToCheckIn, enums.AppointStateEnum.CheckedIn);
                                response.siblingAppointDetailsToCheckIn.forEach(function(appointDetailId) {
                                    $scope.setAppointStateIndicator(appointDetailId, enums.AppointStateEnum.CheckedIn);
                                });
                            }
                            showCheckinNote(response.note);
                        }
                    });
                } else {
                    showCheckinNote(response.note);
                }
            }
        };

        function showCheckinNote(note) {
            if (note != undefined && note != '') {
                showMessage("Appointment Note<br/><br/>" + note);
            }
        }

        var onApptBookStructureSuccess = function(response) {
            appointmentBookLoaded = true;
            WriteStructure(response);
        };

        function onBusinessInfoSucccess(response) {

            businessInfo = response;

            var setting = $scope.getSetting(enums.SettingEnum.AppointmentBookTimeIncrementUsed);
            $rootScope.appointmentBookIncrement = 15;
            if (setting != null)
                {
                switch (setting) {
                case enums.AppointmentIncrementEnum.Min5:
                    $rootScope.appointmentBookIncrement = 5;
                    break;
                case enums.AppointmentIncrementEnum.Min10:
                    $rootScope.appointmentBookIncrement = 10;
                    break;
                case enums.AppointmentIncrementEnum.Min15:
                    $rootScope.appointmentBookIncrement = 15;
                    break;
                }
        }

            $rootScope.culture = $scope.getSetting(enums.SettingEnum.CultureInfo).toLowerCase();

            if ($rootScope.culture === 'en-gb') {
                $rootScope.isAmPmTime = false;
                $rootScope.isMonthBeforeDay = false;
                $rootScope.currencySymbol = '&#xa3;';
                $datepicker.defaults.dateFormat = 'dd/MM/yyyy';
            } else if ($rootScope.culture === 'en-au') {
                $rootScope.isAmPmTime = false;
                $rootScope.isMonthBeforeDay = false;
                $rootScope.currencySymbol = '$';
                $datepicker.defaults.dateFormat = 'dd/MM/yyyy';
            } else {
                $rootScope.isAmPmTime = true;
                $rootScope.currencySymbol = '$';
                $rootScope.isMonthBeforeDay = true;
            }

            moment.locale($rootScope.culture);
        $scope.dateString = moment().format();

        if ($rootScope.isAmPmTime) {
            $rootScope.hours = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
        } else {
            $rootScope.hours = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23];
        }
        $rootScope.minutes = [];
        for (var i = 0; i < 60; i += $rootScope.appointmentBookIncrement) {
            if (i <= 10) {
                $rootScope.minutes.push("0" + i);
            } else {
                $rootScope.minutes.push(i + "");
            }

        }
        $rootScope.amPmDesignator = ['AM', 'PM'];
    };
        //#endregion

        //#region Scope Functions

    $scope.security = security;

    $scope.getSetting = function(settingId) {
            var settings = _.where(businessInfo.settings, { settingId: settingId });
            if (settings.length > 0) {
                return settings[0].value;
            }
            return null;
        };

        var _saveUponDelete = false;
        $scope.deleteAppointment = function(details) {
            divAppointmentDetails.hide();
            if (details.appointDetailId != undefined && details.appointStandingDefinitionId != undefined) {
                showMessage("", {buttonsType: enums.ButtonTypeEnum.OkCancel, customTemplateId:"divDeleteStandingPrompt", callback:function(result) {
                    if (result == enums.MessageBoxButtonResult.Ok) {
                        if ($scope.editAppointmentChoice == 1) {
                            $scope.deleteAppointment({ appointDetailId: details.appointDetailId, clientGlobalId: details.clientGlobalId, startDate: details.startDate });
                        } else {
                            $scope.deleteAppointment({ appointStandingDefinitionId: details.appointStandingDefinitionId });
                        };
                    }
                    $scope.editAppointmentChoice = 1;
                }});
            } else if (details.appointDetailId != undefined) {
                _saveUponDelete = true;
                $scope.appointDetailIdsToDelete = [details.appointDetailId];
                $scope.deleteAppointReason = null;
                showPopup("#divDialogDelete");
                restServer.getAppointHeaderForAppointDetail(details.appointDetailId).then(function (result) {
                    result.data.details.forEach(function(appointDetail) {
                        appointDetail.client = {
                            id: appointDetail.clientGlobalId,
                            firstName: appointDetail.clientFirstName,
                            lastName: appointDetail.clientLastName
                        }
                    });
                    $scope.appointHeaderDelete = result.data;
                });
            } else {
                restServer.deleteAppointStandingDefinition(details.appointStandingDefinitionId, filterBook());
            }
        }

        $scope.deleteAppointmentFromHeader = function(appointHeader, appointDetailIds, saveUponDelete) {
            _saveUponDelete = saveUponDelete;
            $scope.appointDetailIdsToDelete = appointDetailIds;
            $scope.deleteAppointReason = null;
            showPopup("#divDialogDelete");
            $scope.appointHeaderDelete = appointHeader;
        }

        $scope.getAppointReasons = function(filter) {
            return restServer.LoadAppointReasons(filter).then(function(response) {
                return response.data;
            });
        }

        $scope.deleteAppointmentFinal = function() {
            if ($("#divDialogDelete .divSelected").length == 0) {
                showMessage("No appointments are selected to delete.  Make sure at least one appointment is selected to delete.");
                return;
            }

            var setting = $scope.getSetting(enums.SettingEnum.RequireCancellationReasonWhenDeletingAnAppointment);
            if (setting != null && setting.toBoolean() && !isObject($scope.deleteAppointReason)) {
                showMessage("Delete reason is required");
                return;
            }

            showMessage("Are you sure you want to delete the selected appointments?", { buttonsType: enums.ButtonTypeEnum.YesNo, callback: deleteAppointDetailsConfirmation });
        }

        function deleteAppointDetailsConfirmation(response) {
            if (response == enums.MessageBoxButtonResult.Yes) {
                deletedIds = [];
                $("#divDialogDelete .divSelected").each(function(i) {
                    var appointDetailBeingDeleted = _.where($scope.appointHeaderDelete.details, { appointDetailId: $(this).data("detailId") })[0];
                    appointDetailBeingDeleted.stateEnum = enums.StateEnum.Delete;
                    if (isObject($scope.deleteAppointReason)) {
                        appointDetailBeingDeleted.appointReasonItemId = $scope.deleteAppointReason.itemId;
                    }
                    deletedIds.push($(this).data("detailId"));
                });

                if (_saveUponDelete) {
                    restServer.saveAppointHeader($scope.appointHeaderDelete, onDeleteAppointDetailsSuccess);
                } else {
                    hidePopup("#divDialogDelete");
                }
            }
        }

        $scope.editBlock = function(block) {
            divBlockDetails.hide();
            if (block.appointBlockId != undefined && block.appointBlockDefinitionId != undefined) {
                showMessage("", {
                    buttonsType: enums.ButtonTypeEnum.OkCancel,
                    customTemplateId:"divEditBlockDefinitionPrompt",
                    callback: function(result) {
                        if (result == enums.MessageBoxButtonResult.Ok) {
                            if ($scope.editBlockChoice == 1) {
                                $scope.editBlock({
                                    appointBlockId: block.appointBlockId
                                });
                            } else {
                                $scope.editBlock(
                                {
                                    appointBlockDefinitionId: block.appointBlockDefinitionId
                                });
                            };
                        }
                        $scope.editBlockChoice = 1;
                    }
                });
            } else if (block.appointBlockId != undefined) {
                lock("AppointBlock", block.appointBlockId, function() { editBlock(block.appointBlockId); });
            } else {
                lock("AppointBlockDefinition", block.appointBlockDefinitionId, function() {
                    editBlockDefinition(block.appointBlockDefinitionId);
                });
            }
        };

        $scope.deleteBlock = function(block) {
            divBlockDetails.hide();

            if (block.appointBlockId != undefined && block.appointBlockDefinitionId != undefined) {
                showMessage("", {
                    buttonsType: enums.ButtonTypeEnum.OkCancel,
                    customTemplateId:"divDeleteBlockDefinitionPrompt",
                    callback: function(result) {
                        if (result == enums.MessageBoxButtonResult.Ok) {
                            if ($scope.editBlockChoice == 1) {
                                $scope.deleteBlock(
                                    {
                                        appointBlockId: block.appointBlockId,
                                        showSingleDeleteMessage: false
                                    }
                                );
                            } else {
                                $scope.deleteBlock(
                                {
                                    appointBlockDefinitionId: block.appointBlockDefinitionId
                                });
                            };
                        }
                        $scope.editBlockChoice = 1;
                    }
                });
            } else if (block.appointBlockId != undefined) {
                if (block.showSingleDeleteMessage) {
                    showMessage("Are you sure you want to delete?", {
                        buttonsType: enums.ButtonTypeEnum.YesNo,
                        callback: function(result) {
                            if (result == enums.MessageBoxButtonResult.Yes) {
                                restServer.deleteAppointBlock(block.appointBlockId, onDeleteAppointBlockSuccess);
                            }
                        }
                    });
                } else {
                    restServer.deleteAppointBlock(block.appointBlockId, onDeleteAppointBlockSuccess);
                }
            } else {
                restServer.deleteAppointBlockDefinition(block.appointBlockDefinitionId, filterBook());
            }
        }

        $scope.messageDialogOk = function() {
            if (messageConfig.hidePopupOnButtonClick) {
                hidePopup("#divDialogMessage");
            }
            if (messageConfig.callback != undefined) {
                messageConfig.callback(enums.MessageBoxButtonResult.Ok);
            } 
        };

        $scope.messageDialogCancel = function() {
            hidePopup("#divDialogMessage");
            if (messageConfig.callback != undefined) {
                messageConfig.callback(enums.MessageBoxButtonResult.Cancel);
            }

        };

        $scope.messageDialogYes = function() {
            hidePopup("#divDialogMessage");
            if (messageConfig.callback != undefined) {
                messageConfig.callback(enums.MessageBoxButtonResult.Yes);
            }
        };

        $scope.messageDialogNo = function() {
            hidePopup("#divDialogMessage");
            if (messageConfig.callback != undefined) {
                messageConfig.callback(enums.MessageBoxButtonResult.No);
            }
        };

        $scope.copyAppointment = function() {
            if (!isCutting) {
                $scope.action = "Copy";
                isCopying = true;
                CutCopy();
            }

        };

        $scope.cutAppointment = function() {
            if (!isCopying) {
                if ($scope.details.currentAppointStateEnum == enums.AppointStateEnum.CheckedOut) {
                    showMessage("You cannot move an appointment that has already been checked out.");
                    return;
                }

                $scope.action = "Cut";
                isCutting = true;
                CutCopy();
            }
        };

        $scope.confirmAppointment = function() {
            columnBookings.forEach(function(columnBooking) {
                var matchingDetails = _.where(columnBooking.appointments, { appointHeaderId: $scope.details.appointHeaderId });
                matchingDetails.forEach(function(matchingDetail) {
                    $("#" + matchingDetail.appointDetailId + " .confirm").removeClass().addClass("confirm backGreen");
                });
            });
            restServer.confirmAppointDetail($scope.details.appointDetailId);
            $("#divAppointmentDetails").hide();
        };

        $scope.runningLate = function() {
            var newAppointState = $scope.details.currentAppointStateEnum == enums.AppointStateEnum.RunningLate ? enums.AppointStateEnum.Booked : enums.AppointStateEnum.RunningLate;
            restServer.changeAppointDetailState($scope.details.appointDetailId, newAppointState, onChangeAppointDetailStateSuccess);
            $("#divAppointmentDetails").hide();
            $scope.details.currentAppointStateEnum = newAppointState;
        };

        $scope.checkedIn = function() {
            var newAppointState = $scope.details.currentAppointStateEnum == enums.AppointStateEnum.CheckedIn ? enums.AppointStateEnum.Booked : enums.AppointStateEnum.CheckedIn;
            restServer.changeAppointDetailState($scope.details.appointDetailId, newAppointState, onChangeAppointDetailStateSuccess);
            $("#divAppointmentDetails").hide();
            $scope.details.currentAppointStateEnum = newAppointState;
        };

        $scope.noShow = function() {
            var newAppointState = $scope.details.currentAppointStateEnum == enums.AppointStateEnum.NoShow ? enums.AppointStateEnum.Booked : enums.AppointStateEnum.NoShow;
            restServer.changeAppointDetailState($scope.details.appointDetailId, newAppointState, onChangeAppointDetailStateSuccess);
            $("#divAppointmentDetails").hide();
            $scope.details.currentAppointStateEnum = newAppointState;
        };

        $scope.closeDelete = function() {
            hidePopup("#divDialogDelete");
        };

        $scope.filter = function() {
            filterBook();
        };

        $scope.today = function() {
            $scope.selectDay(false);
            $scope.dateString = moment().format();
        }

        $scope.nextDate = function() {
            var numDays = dateType == enums.AppointmentBookDateTypeFilter.Day ? 1 : 7;
            $scope.dateString = moment($scope.dateString).add(numDays, "days").format();
        };

        $scope.previousDate = function() {
            var numDays = dateType == enums.AppointmentBookDateTypeFilter.Day ? -1 : -7;
            $scope.dateString = moment($scope.dateString).add(numDays, "days").format();
        };filterBook

        $scope.selectDay = function(refresh) {
            dateType = enums.AppointmentBookDateTypeFilter.Day;
            $("#dayFilter").attr("src", "img/calendar_day.png?2=2");
            $("#weekFilter").attr("src", "img/calendar_week_off.png?2=2");
            if (refresh)
            {
                filterBook();
            }
        };

        $scope.selectWeek = function() {
            dateType = enums.AppointmentBookDateTypeFilter.Week;
            $("#dayFilter").attr("src", "img/calendar_day_off.png?2=2");
            $("#weekFilter").attr("src", "img/calendar_week.png?2=2");
            filterBook();
        };

        $scope.clearJobFunction = function() {
            $scope.filteredJobFunction = undefined;
        };

        $scope.closeCutCopy = function() {
            $("#divCutCopyDetails").empty();
            $("#divCutCopy").hide();
            if (isCutting) {
                cutCopyIds.forEach(function(cutCopyId) {
                    $("#" + cutCopyId.appointDetailId + "Overlay").hide();
                });
            }
            isCutting = false;
            isCopying = false;
            cutCopyIds = [];
            copyCutAppointDetailId = undefined;
        };

        $scope.standingEditorLocation = "";
        $scope.getStandingEditorLocation = function() {
            return $scope.standingEditorLocation;
        };

        $scope.openStandingEditor = function() {
            $scope.standingEditorLocation = "views/Standing.html";
            showPopup("#divDialogStanding");
        }

        $scope.addStanding = function() {
            $scope.openStandingEditor();
            $scope.$broadcast("addStanding", { repeatRequestAppointType: businessInfo.repeatRequestAppointType });
        }
        $scope.hideStandingEditor = function() {
            hidePopup("#divDialogStanding");
        }

        $scope.blockDefinitionEditorLocation = "";
        $scope.getBlockDefinitionEditorLocation = function() {
            return $scope.blockDefinitionEditorLocation;
        };

        $scope.openBlockDefinitionEditor = function() {
            $scope.blockDefinitionEditorLocation = "views/BlockDefinition.html";
            showPopup("#divDialogBlockDefinition");
        }

        $scope.addBlockDefinition = function() {
            $scope.openBlockDefinitionEditor();
            $scope.$broadcast("addBlockDefinition");
        }
        $scope.hideBlockDefinitionEditor = function() {
            hidePopup("#divDialogBlockDefinition");
        }

        $scope.appointmentEditorLocation = "";
        $scope.getAppointmentEditorLocation = function() {
            return $scope.appointmentEditorLocation;
        };

        $scope.blockEditorLocation = "";
        $scope.getBlockEditorLocation = function() {
            return $scope.blockEditorLocation;
        };

        $scope.clientFindLocation = "";
        $scope.getClientFindLocation = function() {
            return $scope.clientFindLocation;
        }

        $scope.findClient = function() {
            $scope.clientFindLocation = "views/ClientFind.html";
            $rootScope.$broadcast("openClientFind");
            showPopup("#divDialogClientFind");
        }

        $scope.clientFindLocation = "";
        $scope.getClientFindLocation = function() {
            return $scope.clientFindLocation;
        }


        $scope.appointmentBookFiltersLocation = "";
        $scope.getAppointmentBookFiltersLocation = function() {
            return $scope.appointmentBookFiltersLocation;
        };

        $scope.appointmentBookMenuLocation = "";
        $scope.getAppointmentBookMenuLocation = function() {
            return $scope.appointmentBookMenuLocation;
        };

        $scope.editAppointment = function(details) {
            if (details.currentAppointStateEnum == enums.AppointStateEnum.CheckedOut) {
                showMessage("You cannot edit an appointment that has already been checked out.");
                return;
            }

            divAppointmentDetails.hide();
            if (details.appointDetailId != undefined && details.appointStandingDefinitionId != undefined) {
                showMessage("", {
                    buttonsType: enums.ButtonTypeEnum.OkCancel,
                    customTemplateId:"divEditStandingPrompt",
                    callback: function(result) {
                        if (result == enums.MessageBoxButtonResult.Ok) {
                            if ($scope.editAppointmentChoice == 1) {
                                $scope.editAppointment({ appointDetailId: details.appointDetailId, appointHeaderId: details.appointHeaderId });
                            } else {
                                $scope.editAppointment({ appointStandingDefinitionId: details.appointStandingDefinitionId });
                            };
                        }
                        $scope.editAppointmentChoice = 1;
                    }
                });
            } else if (details.appointDetailId != undefined) {
                lock("AppointHeader", details.appointHeaderId, function() { editAppointment(details); });
            } else {
                lock("AppointStandingDefinition", details.appointStandingDefinitionId, function() { editStanding(details.appointStandingDefinitionId); });
            }
        };

        $scope.showFilters = function() {
            divAppointmentDetails.hide();
            $scope.appointmentBookFiltersLocation = appointmentBookFiltersLocation;
            showPopup("#divDialogAppointmentBookFilters");
        };

        $scope.goBackToMainMenu = function () {
            window.history.back();
        };

        $scope.updateFilters = function(jobFunctions, employees, services) {
            $scope.filteredJobFunctions = jobFunctions;
            $scope.filteredEmployees = employees;
            $scope.filteredServices = services;
        };

        $scope.hideAppointmentBookFilters = function() {
            hidePopup("#divDialogAppointmentBookFilters");
        };

        $scope.hideAppointmentBookFilterMenu = function() {
            hidePopup("#divDialogAppointmentBookFilterMenu");
        }

        $scope.showAppointmentBookFilterMenu = function() {
        $scope.appointmentBookMenuLocation = appointmentBookMenuLocation;
        showPopup("#divDialogAppointmentBookFilterMenu");
    }

        $scope.showMenu = function () {
        $scope.currentPopupId = "divAppointmentBookMenu";
            $("#divAppointmentBookMenu").show();
        }

        $scope.hideFindClient = function() {
            hidePopup("#divDialogClientFind");
        }

        $scope.clientEditorLocation = "";
        $scope.getClientEditorLocation = function() {
            return $scope.clientEditorLocation;
        }

        $scope.newAppointment = function() {
            validateNewBook(appointmentDataTypeId);
        };

        $scope.newBlock = function() {
            validateNewBook(blockDataTypeId);
        };

        function validateNewBook(dataTypeId) {
            divNewBooking.hide();
            divCellHighlight.hide();
            var showEditorCallback = function() {
                showEditor(dataTypeId);
            }
            validateBookingLocation(GetColumnId(highlightedCell.date, highlightedCell.employeeGlobalId), {
                    top: highlightedCell.top,
                    height: cellHeight,
                    newBooking: true
                }, highlightedCell,
                showEditorCallback,
                undefined);
        }

        $scope.doubleBook = function() {
            divAppointmentDetails.hide();
            divBlockDetails.hide();
            divCellHighlight.show();
            positionPopup(divNewBooking, divCellHighlight, false);
        };

        $scope.getServices = function(filter) {
            return restServer.LoadFilteredServices(filter).then(function(response) {
                return response.data;
            });
        };

        $scope.getEmployees = function(filter) {
            return restServer.LoadFilteredEmployees(filter).then(function(response) {
                return response.data;
            });
        };

        $scope.getJobFunctions = function(filter) {
            return restServer.LoadFilteredJobFunctions(filter).then(function(response) {
                return response.data;
            });
        };

        $scope.setAppointStateIndicator = function(appointDetailId, currentAppointState) {
            var imageUrl = "";
            var confirm = $("#" + appointDetailId + " .confirm").empty();
            switch (currentAppointState) {
            case enums.AppointStateEnum.RunningLate:
                imageUrl = "img/Status_RunningLate_14.png";
                break;
            case enums.AppointStateEnum.NoShow:
                imageUrl = "img/Status_NoShow_14.png";
                break;
            case enums.AppointStateEnum.CheckedOut:
                $("#" + appointDetailId + " .clientName").css("text-decoration", "line-through");
                $("#" + appointDetailId + " .serviceName").css("text-decoration", "line-through");
                $("#" + appointDetailId + " .serviceShortcut").css("text-decoration", "line-through");
                imageUrl = "img/Status_CheckedOut_14.png";
                break;
            case enums.AppointStateEnum.CheckedIn:
                imageUrl = "img/Status_CheckedIn_14.png";
                break;
            case enums.AppointStateEnum.Booked:
                break;
            }
            if (imageUrl != "") {
                confirm.append("<img src='" + imageUrl + "'/>");
            }
        };

        $scope.hideBlockDetails = function() {
            divBlockDetails.hide();
        }

        $scope.hideAppointmentDetails = function() {
            divAppointmentDetails.hide();
        }

        $scope.cancelAddEditClient = function() {
            hidePopup("#divDialogClientEditor");
        }

        $scope.showProcessingOverlay = function() {
            $("#divProcessingOverlay").show();
        }

        $scope.hideProcessingOverlay = function() {
            $("#divProcessingOverlay").hide();
        }
        //#endregion


        //#region Watches

        $scope.$on("showMessage", function(event, args) {
            showMessage(args.message, args);
        });

    $scope.$on("hideMessage", function(event, args) {
        hidePopup("#divDialogMessage");
    });

        $scope.$on("cancelAppointmentSave", function(event, args) {
            hideAppointmentEditor();
        });

        $scope.$on("cancelBlockSave", function(event, args) {
            hideBlockEditor();
        });

        $scope.$on("appointmentSaved", function(event, args) {
            hideAppointmentEditor();
            refreshColumnsForSave(args.affectedColumns);
        });

        $scope.$on("standingSaved", function() {
            hidePopup("#divDialogStanding");
            filterBook();
        });

        $scope.$on("blockDefinitionSaved", function() {
            hidePopup("#divDialogBlockDefinition");
            filterBook();
        });

        $scope.$on("blockSaved", function(event, args) {
            hideBlockEditor(args.affectedColumns);
            refreshColumnsForSave(args.affectedColumns);
        });

        $scope.$on("openEditAppoitment", function(event, args) {
            if (moment($scope.dateString).format("M-D-YYYY") != moment(args.startDate).format("M-D-YYYY")) {
                dateType = enums.AppointmentBookDateTypeFilter.Day;
                $scope.dateString = moment(args.startDate);
            }
            $scope.editAppointment(args);
            hidePopup("#divDialogClientFind");
        });

        $scope.$on("serverError", function(event, args) {
            $scope.hideProcessingOverlay();
            showMessage(args.message);
        });

        $scope.$on("addEditClient", function(event, args) {
            $scope.clientEditorLocation = "views/ClientEditor.html";
            showPopup("#divDialogClientEditor");
        });

        $scope.$on("editClientCanceled", function() {
            hidePopup("#divDialogClientEditor");
        });

        $scope.$on("clientSaved", function() {
            hidePopup("#divDialogClientEditor");
        });

        $scope.$watch("dateString", function(newValue) {
            if (appointmentBookLoaded) {
                filterBook();
            }
        });

        $scope.$on("menuSelectionsChanged", function(event, args) {
            columnBookings.forEach(function(columnBooking) {
                columnBooking.appointments.forEach(function(appointment) {
                    var overlay = $("#" + appointment.appointDetailId + "Overlay");

                    if ((args.appointStateEnum != -1 && appointment.currentAppointStateEnum != args.appointStateEnum) ||
                    (args.hasNotes && appointment.noteCount == 0) ||
                    (args.bookedOnline && appointment.bookingMethodEnum != enums.BookingMethodEnum.Online) ||
                    (args.numberOfVisits != -1 && ((args.numberOfVisits == enums.NumberOfVisits.Zero && appointment.visitCount != 0) ||
                            args.numberOfVisits == enums.NumberOfVisits.One && appointment.visitCount != 1) ||
                        args.numberOfVisits == enums.NumberOfVisits.FiveOrLess && appointment.visitCount > 5)) {
                        overlay.show();
                    } else {
                        overlay.hide();
                    }
                });
            });
        });

        $scope.showTest = function () {
//            $scope.editAppointment({ appointDetailId: 'dd688541-a187-4641-b9b3-86a4d0490d43' });
            $("#testDiv").show();
        }

        $scope.hideTest = function() {
            $("#testDiv").hide();
        }

        $scope.showTest2 = function () {
            $("#testDiv2").show();
        }

        $scope.hideTest2 = function () {
            $("#testDiv2").hide();
        }
        //#endregion

        detectPhoneMode();
        var promises = [];

        promises.push(restServer.LoadAppointmentBookStructure(dates, [], defaultEmployeeIds, []));
        promises.push(restServer.getUserSecurityAttribs());

        $q.all(promises).then(function(result) {
            security.setSecurityAttribs(result[1].data);
            onApptBookStructureSuccess(result[0].data);
        });
        onBusinessInfoSucccess(busInfo);
}]);