﻿app.controller('AppointmentBookFiltersController', ['$scope', '$http', '$rootScope', 'restServer', function ($scope, $http, $rootScope, restServer)
{
    $scope.selectedJobFunctions = [];
    $scope.selectedEmployees = [];
    $scope.selectedServices = [];
    $scope.selections = {};
    $scope.$on("addEmployeeFilter", function (event, args) {
        $scope.selectedJobFunctions = [];
        $scope.selectedEmployees = [];
        $scope.selectedServices = [];

        restServer.getEmployee(args.employeeId, function(response) {
            $scope.selectedEmployees.push(response);
        });
    });

    $scope.deleteJobFunction = function(index) {
        $scope.selectedJobFunctions.splice(index, 1);
    };

    $scope.deleteEmployee = function (index) {
        $scope.selectedEmployees.splice(index, 1);
    };

    $scope.deleteService = function (index) {
        $scope.selectedServices.splice(index, 1);
    };

    $scope.saveFilters = function() {
        $scope.$parent.updateFilters($scope.selectedJobFunctions, $scope.selectedEmployees, $scope.selectedServices);
        $scope.$parent.hideAppointmentBookFilters();
        $scope.$parent.filter();
    };

    $scope.clear = function() {
        $scope.selectedJobFunctions = [];
        $scope.selectedEmployees = [];
        $scope.selectedServices = [];
        $scope.$parent.updateFilters($scope.selectedJobFunctions, $scope.selectedEmployees, $scope.selectedServices);
        $scope.$parent.filter();

    };


    // Populates Lists
    $scope.jobFunctionChanged = function() {
        if (!isObject($scope.selections.selectedJobFunction) || $scope.selections.selectedJobFunction.id == undefined) {
            return;
        }

        $('#selectedJobFunctionInput').trigger("blur");
        $scope.selectedJobFunctions.push($scope.selections.selectedJobFunction);
        $scope.selections.selectedJobFunction = {};
        $scope.$apply();
    }

    $scope.employeeChanged = function () {
        if (!isObject($scope.selections.selectedEmployee) || $scope.selections.selectedEmployee.id == undefined) {
            return;
        }

        $('#selectedEmployeeInput').trigger("blur");
        $scope.selectedEmployees.push($scope.selections.selectedEmployee);
        $scope.selections.selectedEmployee = {};
        $scope.$apply();
    }

    $scope.serviceChanged = function() {
        if (!isObject($scope.selections.selectedService) || $scope.selections.selectedService.id == undefined) {
            return;
        }

        $('#selectedServiceInput').trigger("blur");
        $scope.selectedServices.push($scope.selections.selectedService);
        $scope.selections.selectedService = {};
        $scope.$apply();
    }
}
]);