﻿app.controller('ClientFindController', [
    '$scope', '$http', 'restServer', 'Enums', '$rootScope', function ($scope, $http, restServer, enums, $rootScope) {
        $scope.appointDetails = undefined;
        $scope.temp = {};
        $scope.$on("openClientFind", function () {
            $scope.appointDetails = undefined;
            $scope.temp.client = undefined;
        });

        $scope.clientChanged = function() {
            $scope.appointDetails = undefined;
            if (!isObject($scope.temp.client)) {
                return;
            }
            
            restServer.getFutureAppointments($scope.temp.client.id).then(function (response) {
                $scope.appointDetails = response.data;
            });
        }

        $scope.hasAppointments = function() {
            return $scope.appointDetails != undefined && $scope.appointDetails.length > 0;
        }

        $scope.hasNoAppointments = function () {
            return $scope.appointDetails != undefined && $scope.appointDetails.length == 0;
        }

        $scope.getClients = function (filter) {
            return restServer.LoadFilteredClients(filter).then(function (response) {
                return response.data;
            });
        }

        $scope.isCheckedIn = function(appointDetail)
        {
            return appointDetail.currentAppointStateEnum == enums.AppointStateEnum.CheckedIn ? 'apptBookButtonLight' : 'apptBookButton';
        }

        $scope.checkInOut = function (appointDetail) {
            appointDetail.currentAppointStateEnum = appointDetail.currentAppointStateEnum == enums.AppointStateEnum.CheckedIn ? enums.AppointStateEnum.Booked : enums.AppointStateEnum.CheckedIn;
            restServer.changeAppointDetailState(appointDetail.appointDetailId, appointDetail.currentAppointStateEnum, function (response) {
                $scope.$parent.setAppointStateIndicator(appointDetail.appointDetailId, appointDetail.currentAppointStateEnum);
            });
        }

        $scope.delete = function(appointDetail) {
            $scope.$parent.deleteAppointment({
                appointDetailId: appointDetail.appointDetailId,
                clientGlobalId: $scope.temp.client.id,
                startDate: appointDetail.startDate
            });
            $scope.$parent.hideFindClient();
        }

        $scope.edit = function (appointDetail, startDate) {
            $rootScope.$broadcast("openEditAppoitment", {
                appointDetailId: appointDetail.appointDetailId, startDate: startDate,
                appointStandingDefinitionId: appointDetail.appointStandingDefinitionId,
                currentAppointStateEnum:appointDetail.currentAppointStateEnum
            });
        }
    }
]);