﻿app.filter('appointDetailsByClientGlobalId', ['Enums', function (enums) {
    return function (appointDetails, clientGlobalId) {
        var filtered = [];
        appointDetails.forEach(function(appointDetail) {
            if (appointDetail.client.id == clientGlobalId  && appointDetail.stateEnum != enums.StateEnum.Delete) {
                filtered.push(appointDetail);
            }
        });
        return filtered;
    };
}]);

app.filter('visitNotesByVisitNoteType', function () {
    return function (visitNotes, visitNoteType) {
        if (visitNoteType != undefined) {
            var filtered = [];
            visitNotes.forEach(function(visitNote) {

                if (visitNote.visitNoteTypeItemId == visitNoteType.visitNoteTypeId) {
                    filtered.push(visitNote);
                }
            });
            return filtered;
        } else {
            return visitNotes;
        }
    };
});

app.filter('client', function () {
    return function (client) {
        if (!isObject(client)) {
            return '';
        };

        return client.lastName + ', ' + client.firstName;
    };
});


app.filter('employee', function () {
    return function (employee) {
        if (!isObject(employee)) {
            return '';
        };

        return employee.code + ': ' + employee.lastName + ', ' + employee.firstName;
    };
});

app.filter('dateTime', ['$rootScope', '$filter', function (root, $filter) {

    return function (theDate, param) {
        var format = '';

        if (param == undefined || param.toLowerCase() === "date") {
            format = 'EEE ';
            if (root.isMonthBeforeDay) {
                format += 'M/d';
            } else {
                format += 'd/M';
            }

            format += "/yyyy ";
        }

        if (param == undefined || param.toLowerCase() === "time") {

            if (root.isAmPmTime) {
                format += 'h:mm a';
            } else {
                format += 'H:mm';
            }
        }

        var angularDateFilter = $filter('date');

        return angularDateFilter(theDate, format);
    }
}]);

app.filter('currencyCustom', ['$filter','$rootScope','$sce',
    function ($filter, $rootScope, $sce) {
        return function (input) {              
            var formattedValue = $filter('currency')(input, $rootScope.currencySymbol);
            return $sce.trustAsHtml(formattedValue);
        }
    }]
 );