﻿
/*
 * Enums Service
 * Last Updated: 3/6/2015
 * 
 * Description:
 * Stores and handles all enums so they can be used throughout the controllers
 */

app.service('Enums', ['$rootScope', function ($rootScope) {
    var service =
    {
        AppointDetailStateEnum: {
            RunningLate: 163,
            CheckedIn: 164,
            NoShow: 166
        },

        ServiceStepTypeEnum: {
            Gap: 100
        },

        ConfirmStateEnum: {
            AwaitingResponse: 1872,
            Confirmed: 155,
            DoNotConfirm: 154,
            LeftMessage: 157,
            Queued: 1869,
            RespondedNo: 1870,
            Unconfirmed: 158
        },

        AppointStateEnum: {
            Arrived: 180,
            Booked: 195,
            Cancelled: 167,
            CheckedIn: 164,
            CheckedOut: 165,
            NoShow: 166,
            RunningLate: 163
        },

        GenderEnum: {
            Male: 92,
            Female: 93,
            Other: 94
        },
        GenderPreferenceEnum: {
            FemaleOnly:109,
            FemalePreferred:106,
            MaleOnly :108,
            MalePreferred:107,
            NoPreference :105  
        },
        AppointmentIncrementEnum: {
            Min5: 1731,
            Min10: 1732,
            Min15: 1733
        },

        SettingEnum: {
            AppointmentBookTimeIncrementUsed: 11,
            RequireCancellationReasonWhenDeletingAnAppointment: 12,
            StartAppointmentBookDayOn:13,
            HideColumnsWithoutSchedules: 29,
            AppointDetailTypeRequired: 58,
            RequireClientPhoneNumber: 98,
            CultureInfo: 79
        },

        PhoneTypeEnum: {
            Fax: 20,
            Home: 22,
            Mobile: 21,
            Other: 23,
            Work: 19
        },

        EmailTypeEnum: {
            General: 175,
            Other: 98,
            Personal: 96,
            Work: 97
        },

        AddressTypeEnum: {
            Home: 64,
            Other: 66,
            Work: 65
        },
        StateEnum: {
            Read: 1,
            Edit: 2,
            Add: 4,
            Delete: 5
        },
        StandingFrequenceyTypeEnum: {
            Daily: 24,
            Weekly: 27
        },
        BlockDefinitionFrequenceyTypeEnum: {
            Daily: 24,
            OneTime: 25,
            Weekly: 27
        },
        BookingMethodEnum: {
            FrontDesk: 151,
            Online: 152
        },
        NumberOfVisits: {
            Zero: 1,
            One: 2,
            FiveOrLess: 3
        },
        AppointNoteTypeEnum: {
            Checkin: 1,
            Register: 2,
            CheckinRegister: 3
        },
        ButtonTypeEnum: {
            Ok: 1,
            OkCancel: 2,
            YesNo: 3
        },
        MessageBoxButtonResult: {
            Ok: 1,
            Cancel: 2,
            Yes: 3,
            No: 4
        },
        AppointmentBookDateTypeFilter: {
            Day: 1,
            Week: 2
        },
        ClientHistoryActionEnum: {
            AddEmployeeAndService: 1,
            AddEmployee: 2,
            AddService:3
        },
        ElevatableEnum:
    {
		Allow:76,
		Restrict:77
    },
        ElevateDurationEnum:
    {
		Screen: 79,
		Transaction: 78
    },
        SecurityAllowEnum:
    {
		Executable:196,
		Hidden:69,
		Read: 72,
		Write: 74
    },
        AlertPriorityLevelEnum:
        {
            High: 4,
            Good: 3,
            Normal: 2,
            Low: 1,
            None: 0
        },
        WeekdayNameEnum:
        {
            Friday:226,
            Monday:222,
            Saturday:227,
            Sunday:228,
            Thursday:225,
            Tuesday:223,
            Wednesday:224
        },
        GetEnumList: function (enumType) {

            var enumList = [];

            for (var property in enumType) {
                if (enumType.hasOwnProperty(property)) {
                    enumList.push({ displayName: property.toString(), value: enumType[property] });
                }
        }

            return enumList;
    }
    };


    return service;

}]);

