﻿app.factory('restServer', [
    '$rootScope', '$http', '$filter', '$location', '$routeParams',
    function($rootScope, $http, $filter, $location, $routeParams) {
        var restServer = {};
        var subdomain = localStorage.getItem('subdomain');

        var baseUrl;
        if (sessionStorage.getItem('BASE_URL') == null) {
            baseUrl = window.location.protocol + "//" + window.location.host + '/Mobile/api/';
        } else {
            baseUrl = sessionStorage.getItem('BASE_URL') + '/Mobile/api/';
        }

        function getUrl(subUrl) {
            return baseUrl + subUrl + '?subdomain=' + subdomain;
        }

        restServer.SetOnSuccessAndError = function(promise, onSuccess, extraData) {
            if (onSuccess) {
                promise.success(function(data, status, headers, config) {
                    onSuccess(data, extraData);
                });
            }

            promise.error(function(data, status, headers, config) {

                if (data.hasOwnProperty("responseStatus")) {
                    console.log(data.responseStatus);
                    $rootScope.$broadcast("serverError", data.responseStatus);
                } else {
                    console.log(data);
                    $rootScope.$broadcast("serverError",
                        {
                            "errorCode": status,
                            "message": data,
                            "stackTrace": ""
                        }
                    );
                }
            });
        }

        
    }
]);