define([], function () {
    'use strict';

    return {
        SaleLineTypes : {
            SERVICE     : 1426,
            PRODUCT     : 1425,
            GIFTCARD    : 1427,
            ACCOUNT     : 1545
        },
        MenuItems: [
            {
                "title": "Appointment Book",
                "url": "appointment-book",
                "locked": false,
                "counter": false,
                "count": "",
                "key": "evo.launchpad.appointmentgroup"
                //"key": "appointmentbook.view.appointmentbook"
            },
            {
                "title": "Smart Center",
                "url": "desktops",
                "locked": false,
                "counter": false,
                "count": ""
            },
            {
                "title": "Sales",
                "url": "sales",
                "locked": false,
                "counter": false,
                "count": "",
                "key": ""
            },
            {
                "title": "Game Alerts",
                "url": "game-messages",
                "locked": false,
                "counter": true,
                "count": 0,
                "key": ""
            },
            {
                "title": "Register",
                "url": "register",
                "locked": false,
                "counter": false,
                "count": "",
                "key": "evo.launchpad.registergroup"
            },
            {
                "title": "Help",
                "url": "help",
                "locked": false,
                "counter": false,
                "count": "",
                "key": ""
            },
            {
                "title": "Appointments",
                "url": "",
                "locked": true,
                "counter": false,
                "count": "",
                "key": ""
            },
            {
                "title": "Schedule",
                "url": "",
                "locked": true,
                "counter": false,
                "count": "",
                "key": ""
            }
        ],
        WidgetDefinitions: [
            {
                "noun": "EstimatedSalesWidget",
                "displayData": [
                    "SalesTypeName",
                    "SalesTypeValue"
                ]
            },
            {
                "noun": "LowInventoryWidget",
                "displayData": [
                    "Shortcut",
                    "DisplayName",
                    "CurrentQuantity"
                ]
            },
            {
                "noun": "AppointmentServiceCountTodayWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentTime",
                    "ServiceShortcut",
                    "EmployeeCode"
                ]
            },
            {
                "noun": "EmployeesOnBreakWidget",
                "displayData": [
                    "EmployeeFirstName",
                    "BreakTimeHHMM"
                ]
            },
            {
                "noun": "RegisterSalesNoRefundsWidget",
                "displayData": [
                    "DisplayName",
                    "TotalQuantity",
                    "TotalPrice"
                ]
            },
            {
                "noun": "NumberOfClientsTodayWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentTime"
                ]
            },
            {
                "noun": "RegisterSalesIncludingRefundsWidget",
                "displayData": [
                    "DisplayName",
                    "TotalQuantity",
                    "TotalPrice"
                ]
            },
            {
                "noun": "AppointmentsNeedingConfirmationWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentDateTime",
                    "ServiceShortcut"
                ]
            },
            {
                "noun": "EmployeesRunningLateWidget",
                "displayData": [
                    "EmployeeFullName",
                    "StartTimeHHMM"
                ]
            },
            {
                "noun": "AppointmentsScheduledWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentDate"
                    //"EmployeeCode",
                    //"ServiceShortcut"
                ]
            },
            {
                "noun": "ClientsNotCheckedOutWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentDateTime",
                    "ServiceShortcut"
                ]
            },
            {
                "noun": "AppointmentCancellationsWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentTime"
                ]
            },
            {
                "noun": "OverdueClientsWidget",
                "displayData": [
                    "ClientDisplayName",
                    "ServiceShortcut"
                ]
            },
            {
                "noun": "NewClientsWidget",
                "displayData": [
                    "ClientName"
                ]
            },
            {
                "noun": "CheckInsDueWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentTime"
                ]
            },
            {
                "noun": "RegisterSalesServiceHoursWidget",
                "displayData": [
                    "InvoiceNumber",
                    "DateTransaction",
                    "ClientLastName",
                    "ClientFirstName",
                    "ServiceHours"
                ]
            },
            {
                "noun": "ClientsRunningLateWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentTime",
                    "ServiceShortcut",
                    "EmployeeCode"
                ]
            },
            {
                "noun": "AppointmentNoShowsWidget",
                "displayData": [
                    "ClientDisplayName",
                    "AppointmentDateTime",
                    "ServiceShortcut",
                    "EmployeeCode"
                ]
            }
        ],
        SalesCharts: [
            {
                "title": "Service Sales",
                "metricType": 1,
                "background": "#8246c2"
            },
            {
                "title": "Product Sales",
                "metricType": 2,
                "background": "#8246c2"
            },
            {
                "title": "Service Sales Per Ticket",
                "metricType": 3,
                "background": "#719e32"
            },
            {
                "title": "Product Sales Per Ticket",
                "metricType": 4,
                "background": "#92278f"
            },
            {
                "title": "% Clients Buying Retail",
                "metricType": 5,
                "background": "#d646f9"
            },
            {
                "title": "Rebook Percent",
                "metricType": 6,
                "background": "#92278f"
            }
        ],
        SaleStateEnum: {
            AutoSave:  1627,
            Completed: 1398,
            Created:   1397,
            Hold:      1399,
            Resume:    1400,
            Void:      1401,
            All:       ''
        }
    };

});
