define([
    'backbone'
], function (Backbone) {
    'use strict';

    var WidgetModel = Backbone.Model.extend({
        defaults: function () {
            return {
                "id": "",
                "row": "",
                "column": "",
                "rowSpan": "",
                "columnSpan": "",
                "widgetName": "",
                "viewNVN": "",
                "requestNoun": "",
                "label": "",
                "displayValue": "",
                "desktopId": "",
                "widgetDefnId": "",
                "values": {},
                "tileBackground": "#FF574493",
                "groupList": [],
                "groupListUpdated": [],
                "groupListRender": []
            }
        }
    });

    var WidgetsCollection = Backbone.Collection.extend({
        model: WidgetModel,
        comparator: function (item) {
            return [item.get("row"), item.get("column")]
        }
    });

    var DesktopsModel = Backbone.Model.extend({
        defaults: function () {
            return {
                "id": "",
                "itemId": "",
                "displayName": "",
                "shortcut": "",
                "description": ""
            }
        },
        widgets: null,

        initialize: function () {
            this.widgets = new WidgetsCollection();
        }
    });

    var Desktops = Backbone.Collection.extend({
        model: DesktopsModel
    });

    return new Desktops;
});