/**
 * Created by petermomot on 3/25/15.
 */
define([
    'backbone'
], function (Backbone) {
    'use strict';

    var DiscountModel = Backbone.Model.extend({
        defaults: {
            amount: 0,
            commissionOnBasePrice: false,
            discountAccountingEnum: 0,
            discountAppliesToEnum: 0,
            discountEffectEnum: 1674,
            displayName: '',
            id: '',
            maxUsesPerClient: 0,
            performRounding: false,
            reason: '',
            isManual: false
        }
    });

    var DiscountsCollection = Backbone.Collection.extend({
        model: DiscountModel,

        beforeCalc: function (discounts) {
            discounts = _.uniq(_.pluck(_.flatten(discounts), 'discountId'));
            var models = this.toJSON();
            _.each(models, function (m) {
                if (_.indexOf(discounts, m.id) == -1) {
                    this.remove(this.get(m.id));
                }
            }.bind(this));
            return this.toJSON();
        }
    });

    return new DiscountsCollection;
});