﻿/**
 * Created by petermomot on 6/3/15.
 */
define([
    'backbone'
], function (Backbone) {
    'use strict';

    var PaymentStateModel = Backbone.Model.extend({
        defaults: {
            amount: 0,
            checked: false,
            date: "",
            description: "",
            id: "",
            isPayInOut: false,
            firstName: '',
            lastName:''
        }
    });

    return Backbone.Collection.extend({
        model: PaymentStateModel,

        getTotal: function (checked) {
            return _.reduce(this.toJSON(), function (memo, elem) {
                if (checked) {
                    return memo + (elem.checked ? elem.amount: 0);
                } else {
                    return memo + elem.amount;
                }
            }, 0);
        },

        getMaxAmount: function () {
            var maxAmount = 0;
            _.each(this.models, function (m) {
                maxAmount += m.get('amount');
            });
            return maxAmount;
        },

        isAllChecked: function () {
            var checked = _.reduce(this.toJSON(), function (memo, elem) {
                return memo + (elem.checked ? 1 : 0);
            }, 0);
            return checked === this.length && checked !== 0 ? 'checked' : '';
        },

        updateChecked: function (elements) {
            _.each(elements, function (elem) {
                this.get(elem.id).set('checked', elem.checked);
            }.bind(this));
        },

        setChecked: function (checked) {
            _.each(this.models, function (m) {
                m.set('checked', checked);
            });
        }
    });
});