define([
    'moment',
    'backbone'
], function (moment, Backbone) {
    'use strict';

    var GameMessage = Backbone.Model.extend({
        defaults: function () {
            return {
                "globalMessageId": "",
                "displayName": "",
                "displayDate": "",
                "headerMessage": "",
                "globalImageId": "",
                "globalImageRelativeUrl": "",
                "achievementMessage": "",
                "messageNote": "",
                "viewed": true,
                "imageUrl": "",
                "updatedDate": ""
            }
        },

        initialize: function () {
            var url = window.IMAGES_BASE_URL + this.get('globalImageRelativeUrl');
            if (window.ImageCache[url]) {
                this.set('imageUrl', 'file://' + window.ImageCache[url]['filePath']);
            } else {
            	this.set('imageUrl', url);
                getGameImageLocalUrl(url, function(state, obj, error) {
                    if (state && (window.ImageCache[url] = obj)) {
                        this.set('imageUrl', 'file://' + window.ImageCache[url]['filePath']);
                    }
                }.bind(this));
            }
            //var m = moment(this.get('displayDate'));
            this.set('updatedDate', this.get('displayDate'));
        }
    });

    /**
     * Collection that contains all game messages
     * @param {Object} model Backbone model
     * */
    var GameMessages = Backbone.Collection.extend({
        model: GameMessage
    });

    return new GameMessages();
});