/**
 * Created by petermomot on 4/6/15.
 */
define([
    'backbone'
], function (Backbone) {
    'use strict';

    var GiftCardModel = Backbone.Model.extend({
        defaults: {
            id: '',
            number: '',
            displayName: '',
            value: '',
            totalUsages: ''
        }
    });

    var GiftCardCollection = Backbone.Collection.extend({
        model: GiftCardModel,

        beforeAdd: function (giftCards, payments) {
            _.each(giftCards, function (o) {
                o['remaining'] = o['value'] - o['totalUsages'];
            });

            if(payments)
            _.each(payments, function (payment) {
                var giftsAlreadyInPayments = _.filter(giftCards, function (giftCard) { return giftCard.id == payment.giftCard.id; });
                _.each(giftsAlreadyInPayments, function (giftCard) { giftCard.remaining -= payment.amount; });
            });

            this.add(giftCards);
        },

        update: function (payments) {

            var giftCards = _.map(this.models, function (giftCard) { return giftCard.toJSON(); });

            _.each(payments, function(payment) {
                var giftsToUpdate = _.filter(giftCards, function (giftCard) { return giftCard.id == payment.giftCard.id; });

                _.each(giftsToUpdate, function (giftCard) {
                    
                    var model = _.find(this.models, function (el) { return el.toJSON().id == giftCard.id; });
                    if (model) {

                        var remainingToSet = giftCard['remaining']+payment.amount;
                        model.set('remaining', remainingToSet);

                        if (giftCard['remaining'] == 0) {
                            giftCard['remaining'] = remainingToSet;
                            this.add([giftCard]);
                        }
                        $('.checkout-gift-line input[data-id="' + giftCard.id + '"]').closest('.checkout-gift-line').find('.remaining-fake-class').html($.global.format(remainingToSet, 'c'));
                    }
                }.bind(this));
            }.bind(this));
        },

        removeAll: function () {
            var models = this.toJSON();
            _.each(models, function (m) {
                this.remove(this.get(m['id']));
            }.bind(this));
        },

        removeByClientId: function (clientId) {
            var toRemove = _.filter(this.models, function (m) {
                return m.get('client')['id'] === clientId;
            });
            this.remove(toRemove);
        }
    });

    return new GiftCardCollection;
});