/**
 * Created by petermomot on 2/17/15.
 */
define([
    'backbone'
], function (Backbone) {
    'use strict';

    return Backbone.Model.extend({
        defaults: {
            id: '',
            payingClientGlobalId: '',
            invoiceNumber: '',
            date: new Date(),
            saleState: 0,
            totalPayments: 0, // total
            totalPrice: 0, // subTotal
            totalTips: 0,
            totalSaleTax1: 0,
            totalSaleTax2: 0,
            totalSaleTax3: 0,
            totalRefundTax1: 0,
            totalRefundTax2: 0,
            totalRefundTax3: 0,
            totalTax1: 0,
            totalTax2: 0,
            totalTax3: 0,
            changeDue: 0,
            saleLines: [],
            tips: [],
            discounts: [],
            payments: [],
            balance: 0
        },

        beforeCalc: function () {
            var model = this.toJSON();
            delete model['services'];
            delete model['employees'];
            delete model['balance'];
            return model;
        },

        reset: function () {
            this.clear().set(this.defaults);
        }
    });
});