/**
 * Created by petermomot on 7/17/15.
 */
define([
    'jquery',
    'underscore',
    'text!../../templates/modal-buttons-bottom.html'
], function ($, _, ButtonsTemplate) {
    'use strict';

    return function (options) {
        var html,
            buttonEvents = {};

        options = _.extend({
            phone: false,
            className: '',
            phoneButtons: [],
            tabletButtons: [],
            events: {},
            touchCallBacks: {}
        }, options);

        html = _.template(ButtonsTemplate)({
            buttons: options.phone ? options.phoneButtons : options.tabletButtons,
            className: options.className
        });

        for (var key in options.touchCallBacks) {
            if (options.touchCallBacks.hasOwnProperty(key)) {
                buttonEvents['touchend #' + key] = options.touchCallBacks[key];
            }
        }

        return {
            modalContentClass: 'before-bottom-buttons',
            html: html,
            events: buttonEvents
        };
    }
});