(function () {
    'use strict';

    if (!Function.prototype.bind) {
        Function.prototype.bind = function (oThis) {
            if (typeof this !== 'function') {
                throw new TypeError('Function.prototype.bind - what is trying to be bound is not callable');
            }
            var aArgs = Array.prototype.slice.call(arguments, 1),
                fToBind = this,
                fNOP = function () {
                },
                fBound = function () {
                    return fToBind.apply(this instanceof fNOP && oThis
                            ? this
                            : oThis,
                        aArgs.concat(Array.prototype.slice.call(arguments)));
                };
            fNOP.prototype = this.prototype;
            fBound.prototype = new fNOP();
            return fBound;
        };
    }

    require.config({
        // un-comment for dev
        // always comment for PROD and QA !!!!!
        // urlArgs: "t=" + (new Date()).getTime(),
        paths: {
            text: '../vendor/text',
            moment: '../vendor/moment-with-locales.min',
            jquery: '../vendor/jquery-2.1.3.min',
            backbone: '../vendor/backbone-min',
            underscore: '../vendor/underscore-min',
            iscroll: '../vendor/iscroll',
            signature: '../vendor/signature_pad',
            swipeview: '../vendor/swipeview',
            jqueryQuickfit: '../vendor/jquery.quickfit',
            chart: '../vendor/chart.min',
            inputFormat: 'custom-plugins/input-format',
            searchPlugin: 'custom-plugins/search-plugin',
            //device: '../vendor/device',
            jqueryglob: '../vendor/jquery.global',
            globinfo: '../vendor/globinfo/jquery.glob.all.min'
        },
        shim: {
            jquery: {exports: '$'},
            moment: {exports: 'moment'},
            underscore: {exports: '_'},
            backbone: {exports: 'Backbone', deps: ['underscore', 'jquery']},
            queue: ['jquery'],
            bridge: ['jquery', 'queue', 'mt'],
            jqueryQuickfit: ['jquery'],
            inputFormat: ['jquery'],
            signature: {exports: 'signature', deps: ['underscore']},
            searchPlugin: ['jquery', 'underscore'],
            jqueryglob: {exports: 'jQuery.global', deps: ['jquery']},
            globinfo: ['jqueryglob'],
            device: {deps: ['jquery']},
            app: ['device', 'globinfo']
        }
    });

    require(['app', 'data/permissions'], function (app) {
        window.app = app;

        onLoadFinished();

        window.maxFontSizeTileText = '';
        window.minFontSizeTileText = 8;
        window.messageFontSize = Math.min(document.documentElement.clientHeight, document.documentElement.clientWidth) * 0.035;
        window.isLocked = false;
        window.inputType = 'number';
        if (navigator.userAgent.match(/SAMSUNG|SGH-[I|N|T]|GT-[I|P|N]|SM-[N|P|T|Z|G]|SHV-E|SCH-[I|J|R|S]|SPH-L/i)) {
            window.inputType = 'text';
        }

        if (window.ImageCache === undefined) {
            window.ImageCache = {};
        }
        if (window.HELP_URL === undefined) {
            window.HELP_URL = "http://help.mymeevo.com";
        }
        if (!window.DEVICE_TYPE) {
            window.DEVICE_TYPE = "Android"; // can be Android or Apple
        }

        if (sessionStorage.getItem('API_BASE_URL')) {
            window.API_BASE_URL = sessionStorage.getItem('API_BASE_URL');
            if (sessionStorage.getItem('sessionId')) {
                ajaxSetup();
                var d = $.Deferred();
                getSettingCall(d);
                getPermissionsCall(d);
            }
        }
        if (sessionStorage.getItem('IMAGES_BASE_URL')) {
            window.IMAGES_BASE_URL = sessionStorage.getItem('IMAGES_BASE_URL');
        }

        //  hiding safari gray highlight
        document.documentElement.style.webkitTouchCallout = "none";
        document.documentElement.style.webkitTapHighlightColor = "rgba(0,0,0,0)";
    });
})();

function preventTouchForIScroll(e) {
    e.preventDefault();
}
