var Queue = (function ($) {
    function Queue() {
        this._ = $.when({});
    };
    Queue.prototype.append = function () {
        var args = $.makeArray(arguments);
        var fn = args.shift();
        if (typeof (fn) != "function") {
            throw new TypeError("1st parameter should be a function");
        }
        var next = function () {
            return $.Deferred(function () {
                try {
                    return fn.apply(this, args);
                } catch (ex) {
                    this.reject(ex);
                }
            });
        };
        return this._ = this._.then(next, next);
    };
    return Queue;
})(jQuery);

var NativeQueue = (function () {
    var currentRequest = $.noop;
    window.NativeQueue$Callback = function () {
        try {
            currentRequest.apply(null, arguments);
        } catch (ex) {
            alert(ex);
        }
    };
    function NQueue() {
        this.q = null;
        this._ = null;
    };
    NQueue.prototype = {
        exec: function () {
            var args = $.makeArray(arguments), fn = args.shift(), name = null;
            if (typeof (fn) != 'function') {
                name = fn;
                fn = null;
            }
            if (this.q == null) {
                Mt.App.fireEvent('setQueueStatus', {isBusy: true});
                this.q = new Queue();
            }
            return this._ = this.q.append(function () {
                if (fn != null) {
                    try {
                        fn.apply(null, args).then(this.resolve.bind(this), this.reject.bind(this));
                    } catch (ex) {
                        alert(ex);
                        this.reject();
                    }
                } else {
                    currentRequest = this.resolve.bind(this);
                    Mt.App.fireEvent(name, $.extend({}, args.shift() || {}, {
                        callback: 'NativeQueue$Callback'
                    }), this.resolve.bind(this));
                }
            }).always(function () {
                if (this._.state() != 'pending') {
                    this.q = null;
                     Mt.App.fireEvent('setQueueStatus', {isBusy: false});
                }
            }.bind(this));
        },
        empty: function () {
            return this.q == null;
           

        }
    };
    return new NQueue();
})();