/**
 * Created by petermomot on 3/9/15.
 */
define([
    'jquery',
    'views/modal',
    'text!../../../templates/drawer/drawer-close-diff-modal.html'
], function ($, ModalView, DrawerCloseDiffTemplate) {
    'use strict';

    return ModalView.extend({
        el: '#drawer-close-diff-modal .content',
        template: _.template(DrawerCloseDiffTemplate),
        scrollbars: false,

        initialize: function (options) {
            this.model = new Backbone.Model(options);
            this.model.set('closeReason', '');
            this.events = _.extend(ModalView.prototype.events, this.events);
        },

        events: {
            'tap .button': 'tapButton'
        },

        tapButton: function (e) {
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            this.trigger('returnReason', {
                _continue: e.target.classList.contains('continue'),
                reason: this.$('#difference-reason').val()
            });
            this.closeView();
        }
    });
});
