/**
 * Created by petermomot on 12/16/14.
 */
define([
    'views/modal',
    'data/game-messages',
    'text!../../templates/game-message-details.html',
    'bridge'
], function (ModalView, gameMessagesList, gameMessageDetailTemplate) {
    'use strict';

    return ModalView.extend({
        el: '#game-message-modal .content',
        className: 'message-details',
        template: _.template(gameMessageDetailTemplate),
        scrollWrap: '#message-details-wrapper',
        returnToList: false,
        refreshList: false,

        initialize: function (args) {
            this.model = gameMessagesList.findWhere({"globalMessageId": args.messageId});
            this.returnToList = args.returnToList;
            this.refreshList = args.refreshList;

            if (this.model.get('viewed') == false) {
                gameMessageMarkAsRead(args.messageId);
                this.model.set('viewed', true);
            }
            this.model.on('change:imageUrl', function () {
                this.$('.img').css({
                    'background-image': 'url(\'' + this.model.get('imageUrl') + '\')',
                    'background-size': '100% 100%'
                });
            }, this);
        },

        render: function () {
            ModalView.prototype.render.call(this);

            this.$('.img').css({
                'background-image': 'url(\'' + this.model.get('imageUrl') + '\')',
                'background-size': '100% 100%'
            });
            // set height on content for iScroll if there is message note
            if (this.model.get('messageNote')) {
                this.setHeight();
            }
            lockScreenToPortraitMode(true);

            return this;
        },

        setHeight: function () {
            var $content = $('#game-message-modal').find('.content');
            $content.find('.details-wrapper').css({
                'height': $content.height()
            });
        },

        closeView: function (e, route) {
            route = route === undefined ? '' : route;
            if (e) {
                e.preventDefault();
                e.stopPropagation();
            }

            ModalView.prototype.closeView.call(this, this.refreshList ? null : e, route);

            if (this.refreshList) { // came from push on login
                setTimeout(function() {
                    Backbone.history.navigate('game-messages', {trigger: true});
                }, 300);
            } else {
                // opened in message history
                if ('' + this.returnToList === 'true') {
                    // do nothing, just return to message history
                } else { // came from push in running app
                    if (route.indexOf('game-messages') != -1) {
                        // do nothing, push came just after other push
                    } else {
                        setTimeout(function () {
                            lockScreenToPortraitMode(false);
                        }, 0);
                    }
                }
            }
        }
    });
});
