/**
 * Created by petermomot on 5/26/15.
 */
define([
    'jquery',
    'views/yes-no-modal',
    'text!../../templates/permissions-modal.html'
], function ($, YesNoModalView, YesNoTemplate) {
    'use strict';

    return YesNoModalView.extend({
        el: '#permissions-modal .content',
        template: _.template(YesNoTemplate),

        initialize: function (options) {
            YesNoModalView.prototype.initialize.call(this, options);
            this.events = _.extend({}, YesNoModalView.prototype.events, this.events);
        },

        events: {
            'focus input': 'focusInput'
        },

        focusInput: function (e) {
            $(e.target).removeClass('error');
        },

        validateForm: function () {
            var $loginField = this.$('#permission-login-field'),
                $passField = this.$('#permission-pass-field'),
                data = {
                    'username': $loginField.val(),
                    'password': $passField.val()
                },
                errors = false;
            if (!data['username']) { $loginField.addClass('error'); errors = true; }
            if (!data['password']) { $passField.addClass('error'); errors = true; }
            if (errors) return false;
            return data;
        },

        tapButton: function (e) {
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            
            if (e.target.classList.contains('cancel')) {
                this.model.get('negativeCallback').call(this);
            } else {
                this.$('.error-message').slideUp().html('');
                var data = this.validateForm();
                if (!data) return false;

                // TODO add loading spinner maybe?
                $('#glass').show();
                this.$el.addClass('loading');
                userCanPerformAction(data['username'], data['password'], this.model.get('securityKey')).done(function (r) {
                    $('#glass').hide();
                    this.$el.removeClass('loading');
                    if (!r) {
                        this.model.get('positiveCallback')();
                        this.closeView();
                    } else {
                        this.$('.error-message').html(r.message).slideDown();
                    }
                }.bind(this));
            }
        }
    });
});
