define([
    'jquery',
    'views/modal',
    'text!../../../templates/smart-receipt/change-as-tip-modal.html',
    'bridge'
], function ($, ModalView, ChangeAsATipModalTemplate) {
    'use strict';

    return ModalView.extend({
        el: '#change-as-tip-modal .content',
        template: _.template(ChangeAsATipModalTemplate),
        scrollWrap: '#change-as-tip-modal-scroll-wrap',
		options: undefined,

        initialize: function (options) {
            this.model = new Backbone.Model(options);
            this.events = _.extend({}, ModalView.prototype.events, this.events);
			if(this.options === undefined)
				this.options = options;
        },
		render: function () {
			ModalView.prototype.render.call(this);
			if(this.options.changeTotal !== undefined)
				$('#initial-change').html(this.options.changeTotal);
			return this;
		},
        events: {
            'tap #apply-as-tip, #submit-sale, #close-tip': 'performAction'
        },

        performAction: function (e) {
            switch ($(e.target).attr('id')) {
                case 'apply-as-tip':
                    this.trigger('finalize', 'showTips');
                    break;
                case 'submit-sale':
                    this.trigger('finalize', 'finalize');
                    break;
            }
            this.closeView();
        }

    });
});
