﻿/**
 * Created by petermomot on 6/25/15.
 */
define([
    'jquery',
    'moment',
    'data/consts',
    'data/permissions',
    'data/hold-transactions',
    'views/smart-receipt/on-hold-modal',
    'views/yes-no-modal',
    'text!../../../templates/smart-receipt/on-hold-deleted-modal.html',
    'text!../../../templates/smart-receipt/on-hold-line.html',
    'text!../../../templates/smart-receipt/bread-crumbs.html',
    'bridge'
], function ($, moment, Consts, PermModel, OnHoldCollection, HoldBaseModalView, YesNoModal, HoldModalTemplate, HoldItemTemplate, BreadCrumbsTemplate) {
    'use strict';

    return HoldBaseModalView.extend({
        el: '#tablet-on-hold-deleted-modal .content',
        template: _.template(HoldModalTemplate),
        transactionsType: ' deleted',
        events: {
            'tap .hold-item-restore': 'holdItemRestore'
        },
        modalButtonsBottom: {
            phone: false,
            phoneButtons: [
                {
                    id: 'on-hold-cancel',
                    className: 'red',
                    size: '100',
                    value: 'cancel'
                }
            ],
            tabletButtons: [
                {
                    id: 'on-hold-cancel',
                    className: 'red',
                    size: '100',
                    value: 'cancel'
                }
            ],
            touchCallBacks: {
                'on-hold-cancel': 'tapCancel'
            }
        },

        initialize: function (options) {
            var o = _.extend({}, options, {
                phone: $('html').hasClass('mobile'),
                PermModel: PermModel
            });
            if (o.phone) {
                this.el = '#on-hold-deleted-modal .content';
                this.setElement(this.el);
                this.breadCrumbs = ['Register', 'On Hold', 'Deleted'];
                this.modalButtonsBottom.phone = true;
            }
            this.model = new Backbone.Model(o);
            HoldBaseModalView.prototype.initialize.call(this, options);

            this.events = _.extend({}, HoldBaseModalView.prototype.events, this.events);
        },

        onRender: function () {
            this.getSalesAndRender();
            this.$el.addClass('hold-deleted');
        },

        customClose: function (whereToGo) {
            whereToGo = whereToGo && whereToGo.type == 'returnToMenu' ? whereToGo : {
                type: 'back'
            };
            this.trigger('holdDeletedEvent', whereToGo);
            this.resetAll();
            this.closeView();
        },

        holdItemRestore: function (e) {
            PermModel.navigateToPermissionsModal(e, function () {
                restoreDeletedHoldSale($(e.target).data('id')).done(function (r) {
                    this.customClose('back');
                    //this.getSalesAndRender();
                    //this.trigger('holdDeletedEvent', {
                    //        type: 'refreshList'
                    //});
                }.bind(this));
            }.bind(this));
        },

        getSalesCallback: function (r) {
            this.holdCollection && this.holdCollection.add(_.map(r, function (model) {
                return _.extend(model, { deleted: true });
            }));
        }
    });
});
