/**
 * Created by petermomot on 4/29/15.
 */
define([
    'jquery',
    'data/permissions',
    'views/modal',
    'text!../../../templates/smart-receipt/sub-menu-modal.html',
    'text!../../../templates/smart-receipt/sub-menu-buttons.html'
], function($, PermModel, ModalView, SubMenuTemplate, SubMenuButtonsTemplate){
    'use strict';

    return ModalView.extend({
        template: _.template(SubMenuTemplate),
        scrollbars: false,
        modalButtonsBottom: {
            phone: true,
            className: 'without-overlay',
            phoneButtons: [
                {
                    id: 'sub-menu-close',
                    className: 'details-close',
                    size: '',
                    value: ''
                }
            ],
            touchCallBacks: {
                'sub-menu-close': 'tapCancel'
            }
        },

        initialize: function(options) {
            this.breadCrumbs = options.breadCrumbs;
            this.events = _.extend({}, ModalView.prototype.events, this.events);
            this.model = new Backbone.Model(_.extend(options, {
                buttonsTemplate: _.template(SubMenuButtonsTemplate)
            }));
            this.el = options.el;
        },

        events: {
            'tap .sub-menu-item': 'navigateTo'
        },

        navigateTo: function (e) {
            PermModel.navigateToPermissionsModal(e, function () {
                var $target = $(e.target);
                this.customClose({
                    url: $target.data('url'),
                    title: $target.html()
                });
            }.bind(this));
        },

        customClose: function (r) {
            if (r.type && r.type == 'returnToMenu') {
                r = 'register';
            }
            this.trigger('closeEvent', r);
            this.closeView();
        },

        tapCancel: function () {
            this.customClose('cancel');
        }

    });
});