﻿/**
 * Created by petermomot on 7/6/15.
 */
define([
    'jquery',
    'moment',
    'data/consts',
    'data/permissions',
    'data/transactions',
    'views/yes-no-modal',
    'views/smart-receipt/transactions-modal',
    'text!../../../templates/smart-receipt/transactions-list-modal.html',
    'bridge'
], function ($, moment, Consts, PermModel, transactionsCollection,
             YesNoModal, TransactionBaseModal,
             TransactionsListModalTemplate) {
    'use strict';

    return TransactionBaseModal.extend({
        el: '#sales-transactions-list-modal .content',
        template: _.template(TransactionsListModalTemplate),
        modalButtonsBottom: {
            phone: true,
            phoneButtons: [
                {
                    id: 'transactions-cancel',
                    className: 'red',
                    size: '100',
                    value: 'cancel'
                }
            ],
            touchCallBacks: {
                'transactions-cancel': 'tapCancel'
            }
        },

        initialize: function (options) {
            var o = _.extend({}, options, {
                phone: true,
                PermModel: PermModel
            });
            this.breadCrumbs = ['Register', 'Transactions', options.criteria];
            this.collectedFilterInfo = options.collectedFilterInfo;
            this.model = new Backbone.Model(o);
            TransactionBaseModal.prototype.initialize.call(this, options);
            this.addListeners();
        },

        onRender: function () {
            if (this.transactionsCollection.collectionEmpty) {
                this.transactionsCollectionEmpty();
            }
        },

        customClose: function (response) {
            if (response) this.trigger('transactionFilteredEvent', response);
            else this.trigger('transactionFilteredEvent', { type: 'cancel' });
            this.closeView();
            this.resetAll();
        },

        transactionVoidCallback: function () {
            this.transactionsCollection.reset();
            this.collectedFilterInfo.pageNumber = 0;
            this.getTransactionsAndRender();
        }
    });
});