/**
 * Created by petermomot on 12/16/14.
 */
define([
    'views/modal',
    'data/desktops',
    'text!../../templates/widget-details.html',
    'bridge'
], function (ModalView, desktopLists, widgetDetailTemplate) {
    'use strict';

    return ModalView.extend({
        el: '#smart-center-modal .content',
        className: 'widget-details',
        template: _.template(widgetDetailTemplate),
        scrollWrap: '#widget-details-wrapper',

        initialize: function (args) {
            this.model = desktopLists.get(args.desktopId).widgets.get(args.widgetId);
            $(window).on("orientationHandlerCallback", this.setHeight);
        },

        setHeight: function () {
            var $content = $('#smart-center-modal').find('.content');
            var $detailsTitle = $content.find('.widget-details-title');
            var detailsTitleHeight = $detailsTitle.height() + +$detailsTitle.css('margin-bottom').slice(0, -2);
            $content.find('.details-wrapper').css({
                'height': $content.height() - detailsTitleHeight
            });
        }
    });
});
