define([
    'common/base-view',
    'text!../../templates/widget.html'
], function (BaseView, widgetTemplate) {
    'use strict';

    return BaseView.extend({
        tagName: 'div',
        className: 'tile',
        template: _.template(widgetTemplate),

        initialize: function () {
            this.model.on('change', this.render, this);
        },

        events: {
            'tap .active': 'showMore'
        },

        render: function () {
            this.$el.attr('id', this.model.get('id'));
            this.$el.html(this.template(this.model.toJSON()));
            this.setBackGroundColor(this.model.get('tileBackground'));
            return this;
        },

        setBackGroundColor: function (color) {
            this.$el.css('background-color', color.replace(/.*(\w{6})$/, '#$1'));
        },

        showMore: function () {
            Backbone.history.navigate('desktops/' + this.model.get('desktopId') + '/' + this.model.get('id'), {trigger: true});
            return true;
        }

    });
})
