/**
 * Created by petermomot on 3/9/15.
 */
define([
    'jquery',
    'views/modal',
    'text!../../templates/yes-no-modal.html'
], function ($, ModalView, YesNoTemplate) {
    'use strict';

    return ModalView.extend({
        el: '#yes-no-modal .content',
        scrollWrap: '#yes-no-scroll-wrap',
        template: _.template(YesNoTemplate),

        initialize: function (options) {
            this.model = new Backbone.Model(_.extend({escapeHtml: false}, options));
            this.events = _.extend({}, ModalView.prototype.events, this.events);
            if (options.restricted) {
                this.el = "#restricted-client-modal .content";
                this.setElement(this.el);
            }
        },

        events: {
            'tap .button': 'tapButton'
        },

        render: function () {
            ModalView.prototype.render.call(this);

            document.activeElement.blur();
            $(':focus').blur();
            document.body.focus();

            this.$el.attr('class', 'content');

            if(this.model.get('className')) {
                this.$el.addClass(this.model.get('className'));
            }

            if ($('html').hasClass('tablet')) {
                var height = '';
                // reset height
                this.$el.height('');
                if (this.model.get('wide')) {
                    height = this.$('.scroll-wrap').children().height();
                }
                if (this.model.get('height')) {
                    height = this.model.get('height')
                }
                //set height
                if (height > 250) {
                    this.$el.height(height);
                }
                this.scroll.refresh();
            }

            return this;
        },

        tapButton: function (e) {
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            if (this.model.get('noCallback')) {
                this.closeView();
            } else {
                var negativeCallbackObject = this.model.get('negativeCallback'),
                    positiveCallbackObject = this.model.get('positiveCallback');
                if (e.target.classList.contains('cancel')) {
                    if (typeof negativeCallbackObject == 'function') {
                        negativeCallbackObject.call(this);
                    } else {
                        this.trigger(negativeCallbackObject['triggerEvent'], negativeCallbackObject['sendProperty']);
                        this.closeView();
                    }
                } else {
                    if (typeof positiveCallbackObject == 'function') {
                        positiveCallbackObject.call(this);
                    } else {
                        this.trigger(positiveCallbackObject['triggerEvent'], positiveCallbackObject['sendProperty']);
                        this.closeView();
                    }
                }
            }
        }

    });
});
